<?php

namespace backend\modules\reports\models;

use yii\base\Model;
use yii\data\ActiveDataProvider;

/**
 * CashFlowReportSearch represents the model behind the search form of `backend\modules\reports\models\CashFlowReport`.
 */
class CashFlowReportSearch extends CashFlowReport
{
    public $from;
    public $to;
    public $from_date;
    public $to_date;
    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['inflow', 'outflow', 'net_flow'], 'number'],
            [['month_year','from','to','from_date','to_date'], 'string', 'max' => 20],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = CashFlowReport::find();
        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'inflow' => $this->inflow,
            'outflow' => $this->outflow,
            'net_flow' => $this->net_flow,
        ]);


        if (!empty($this->from) && !empty($this->to)) {
            $query->andFilterWhere(['between', 'month_year', $this->from, $this->to]);
        }else{
            $query->andFilterWhere(['like', 'month_year', date('Y-m')]);
        }

        return $dataProvider;
    }
}
