<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use yii\widgets\ActiveForm;
use backend\modules\master\models\Product;
use backend\modules\master\models\Vendor;
use common\models\User;

/* @var $this yii\web\View */
/* @var $searchModel backend\modules\users\models\SaleOrderSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Cash Flow';
$this->params['breadcrumbs'][] = $this->title;
// Set default values for from and to if not provided
$currentMonthYear = date('Y-m');
$from = $model->from ?: $currentMonthYear;
$to = $model->to ?: $currentMonthYear;
?>
<style>
input[type="month"]::-webkit-calendar-picker-indicator {
    background: none;
    bottom: 0;
    color: transparent;
    cursor: pointer;
    height: auto;
    left: 0;
    position: absolute;
    right: 0;
    top: 0;
    width: auto;
}
    .text-wrap{
        white-space: -moz-pre-wrap !important;  /* Mozilla, since 1999 */
        white-space: -pre-wrap;      /* Opera 4-6 */
        white-space: -o-pre-wrap;    /* Opera 7 */
        white-space: pre-wrap;       /* css-3 */
        word-wrap: break-word;       /* Internet Explorer 5.5+ */
        white-space: -webkit-pre-wrap; /* Newer versions of Chrome/Safari*/
        word-break: break-all;
        white-space: normal;
    }
    .select2-container .select2-selection--single {
        height: 42px !important;
    }
    .select2-container--default .select2-selection--single .select2-selection__rendered
    {
        line-height: 39px;
    }
    .select2-container--default .select2-selection--single .select2-selection__arrow
    {
        height: 39px;
    }
    .add_product .select2-selection__rendered {
        width: 220px !important;
    }
    th a{
        color:#495057;
    }
    th a:hover{
        color:#495057;
    }
    body{
        font-family:Arial, Helvetica, sans-serif;
        font-size:13px;
    }
    .form-control {
        transition: all .2s;
        font-family: Arial, Helvetica, sans-serif;
        font-size: 13px;
    }
    .pagination li.active a {
        z-index: 1;
        color: #fff;
        background-color: #16aaff;
        border-color: #16aaff;
    
    }
    .right-align {
        text-align: right;
    }
</style>
<?php
$total_outflow=0;$total_inflow=0;
if (!empty($dataProvider->getModels())) {
    foreach ($dataProvider->getModels() as $key => $val) {
        $total_inflow+=$val->inflow;
        $total_outflow+=$val->outflow;
    }
}
?>
<?php if (Yii::$app->session->hasFlash('success')) {?>
    <div class="alert alert-success" style="background-color:#dff0d8 !important; text-align:center">
        <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
        <strong style="color:#3c763d"><?=Yii::$app->session->getFlash('success');?></strong>
    </div>
<?php }?>
<?php if (Yii::$app->session->hasFlash('error')): ?>
    <div class="alert alert-danger alert-dismissable" style="text-align:center">
        <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
        <?= Yii::$app->session->getFlash('error') ?>
    </div>
<?php endif; ?>

<div class="app-main__inner">
    <div class="card no-shadow bg-transparent no-border rm-borders mb-3">
        <div class="card">
            <div class="no-gutters row">
                <div class="col-md-12 col-lg-12">
                    <ul class="list-group list-group-flush">
                        <li class="bg-transparent list-group-item">
                            <div class="widget-content p-0">
                                <div class="widget-content-outer">
                                    <div class="widget-content-wrapper">
                                        <div class="widget-content-left">
                                            <div class="widget-numbers dj-text-success">Cash Flow</div>
                                        </div>
                                        <div class="widget-content-right">
                                            <div class="djsec-text-right dj-print-sec">

                                                <?php if(Yii::$app->request->getQueryParams()){?>
                                                    <a href="<?=Url::current()?>&print=true" data-method="post">  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-print" aria-hidden="true"></i>  Print</button></a>
                                                <?php } else{ ?>
                                                    <a href="<?=Url::current()?>?print=true" data-method="post">  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-print" aria-hidden="true"></i>  Print</button></a>
                                                <?php } ?>
                                                <?php if(Yii::$app->request->getQueryParams()){?>
                                                <a href="<?=Url::current()?>&excel=true" data-method="post"> <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-excel-o"></i>  Excel</button></a>
                                                <?php } else{ ?>
                                                    <a href="<?=Url::current()?>?excel=true" data-method="post">  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-excel-o"></i> Excel</button></a>
                                                <?php } ?>
                                                <?php if(Yii::$app->request->getQueryParams()){?>
                                                    <a href="<?=Url::current()?>&pdf=true" data-method="post">  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-excel-o" aria-hidden="true"></i>  Pdf</button></a>
                                                <?php } else{ ?>
                                                    <a href="<?=Url::current()?>?pdf=true" data-method="post">  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-excel-o" aria-hidden="true"></i>  Pdf</button></a>
                                                <?php } ?>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </li>

                    </ul>
                </div>
            </div>
        </div>
    </div>
    <div class="main-card mb-3 card">
        <div class="card-body">
            <div class="row dj-adv-search-row">
                <div class="col-md-11">
                    <a id="advance-search" class="search_field_buttons" data-toggle="collapse" href="#search-look" role="button" aria-expanded="false" aria-controls="search-look" type="button">Advance Search <i class="fa fa-chevron-down" aria-hidden="true"></i></a>
                </div>
                <div class="col-md-1">
                    <a  class="search_field_buttons"  href="<?=Url::base().'/reports/cash-flow/index'?>" role="button" aria-expanded="false" aria-controls="search-look" type="button" title='Refresh Page'><i class="fa fa-refresh" aria-hidden="true"></i></a>
                </div>
            </div>
            <div class="dj-sale-form collapse" id="search-report">
                <?php $form = ActiveForm::begin(['method' => 'get']); ?>
                <div class="form-row">
                    <div class="col-md-6">
                        <div class="position-relative form-group">
                            <label for="notes">From Period</label>
                            <?= $form->field($model, 'from')->textInput([
                                'type' => 'month',
                                'maxlength' => true,
                                'class' => "form-control",
                                'value' => $from, // Set default value
                            ])->label(false) ?>
                        </div>
                    </div>
                    <div class="col-md-6">
                        <div class="position-relative form-group">
                            <label for="notes">To Period</label>
                            <?= $form->field($model, 'to')->textInput([
                                'type' => 'month',
                                'maxlength' => true,
                                'class' => "form-control",
                                'value' => $to, // Set default value
                            ])->label(false) ?>
                        </div>
                    </div>
                </div>
                <div class="col-md-12 dj-btn-align djsec-text-right">
                    <?= Html::submitButton('<span class="fa fa-search"></span> Search', ['class' => 'btn btn-info btn-rounded dj-search', 'style' => "padding: 9px 21px"]) ?>
                </div>
                <?php ActiveForm::end(); ?>
            </div>
        </div>
    </div>
    <div class="main-card mb-3 card">
        <div class="card-body">
            <?= GridView::widget([
                'dataProvider' => $dataProvider,
                'showFooter' => true,
                'footerRowOptions'=>['style'=>'font-weight:bold;'],
                "id" => "grid",
                'columns' => [
                    [
                        'label'=>'Particular',
                        'attribute'=>'month_year',
                        'format'=>'raw',
                        'value'=>function($data){
                            return Html::a(Html::encode(date('F-Y',strtotime($data->month_year))), Url::base().'/reports/cash-flow/detailed-transaction?first_day='.date("Y-m-01", strtotime($data->month_year)).'&last_day='.date("Y-m-t", strtotime($data->month_year)));
                        },
                        'footer'=>'Grant Total',
                    ],
                    [
                        'attribute' => 'inflow',
                        'contentOptions' => ['class' => 'right-align'],
                        'footerOptions' => ['class' => 'right-align'],
                        'value' => function ($model) {
                            return $this->context->indianCurrencyFormat($model->inflow);
                        },
                        'footer' => $this->context->indianCurrencyFormat($total_inflow),
                    ],
                    [
                        'attribute' => 'outflow',
                        'contentOptions' => ['class' => 'right-align'],
                        'footerOptions' => ['class' => 'right-align'],
                        'value' => function ($model) {
                            return $this->context->indianCurrencyFormat($model->outflow);
                        },
                        'footer' => $this->context->indianCurrencyFormat($total_outflow),
                    ],
                    [
                        'attribute' => 'netflow',
                        'contentOptions' => ['class' => 'right-align'],
                        'footerOptions' => ['class' => 'right-align'],
                        'value' => function ($model) {
                            return $this->context->indianCurrencyFormat($model->inflow - $model->outflow);
                        },
                        'footer' => $this->context->indianCurrencyFormat($total_inflow - $total_outflow),
                    ],
                ],
            ]); ?>
        </div>
    </div>
</div>
    <?php ob_start();?>
<script type="text/javascript">
    $(function() {
        $('#advance-search').click(function(){
            $('#search-report').toggle();
        });
    var today = new Date();
    if(today.getMonth()+1<=9)
    {
        var date =today.getFullYear()+'-'+("0" +(today.getMonth()+1)).slice(-2);
    }
    else
    {
        var date =today.getFullYear()+'-'+("0" +(today.getMonth()+1)).slice(-2);
    }
    <?php if(isset($model->from)&& isset($model->to)){?>
    var date_mod_from= "<?=$model->from?>";
    var date_mod_to= "<?=$model->to?>";

    $('#cashflowreport-from').val(date_mod_from);
    $('#cashflowreport-to').val(date_mod_to);   
    <?php }else{?>
    $('#cashflowreport-from').val(date);
    $('#cashflowreport-to').val(date);   
    <?php } ?>
    
    
    });
</script>
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean()))?>
