<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;
use yii\helpers\Url;
use yii\helpers\ArrayHelper;
use backend\modules\master\models\Customer;
use backend\modules\users\models\Invoice;
use backend\modules\users\models\AdjustedInvoices;
use backend\modules\users\models\DirectReceipt;
use backend\modules\master\models\AccountingLedger;
use backend\modules\master\models\SalesTemplates;
use backend\modules\master\models\GenericTemplate;

if(date("m")>=4)
{
    $dt = (date('Y', strtotime('+0 year'))).'-'.(date('y', strtotime('+1 year')));
}
else
{
    $dt = (date('Y', strtotime('-1 year'))).'-'.(date('y', strtotime('+0 year')));
}

$customer = Customer::find()->where(['id' => $model->customer_name])->one();
if ($customer)
    $openingtotal = AdjustedInvoices::find()->where(['type' => "opening", 'customer_id' => $model->customer_name])->sum('`amount_adjusted`+`tds_amount`') + $customer->opening_as_on;
else
    $openingtotal = 0;
/* @var $this yii\web\View */
/* @var $model backend\modules\users\models\ReceiptDetails */
/* @var $form yii\widgets\ActiveForm */
//$income = AccountingLedger::find()->where(['account_type_id' => 4])->andWhere(['<>', 'group_name_id', '28'])->all();
$income = AccountingLedger::find()->all();
// $income=AccountingLedger::find()->where(['or',['account_type_id'=>2],['account_type_id'=>4]])->all();
// $liability=AccountingLedger::find()->where(['account_type_id'=>5])->all();
$incomes = '';
foreach ($income as $value) {
	$name = str_replace("'", "\'", $value->ledger_id);
    $incomes .= "<option value=\"$value->accounting_ledger_id\">$name</option>";
}

$vendor = AccountingLedger::find()->where(['account_type_id' => 3])->andWhere(['=', 'group_name_id', '29'])->all();
$vendors = '';
foreach ($vendor as $value) {
    $vendors .= "<option value=$value->accounting_ledger_id>$value->ledger_id</option>";
}

$bank = AccountingLedger::find()->where(['account_type_id' => 2])->andWhere(['=', 'group_name_id', '3'])->all();
$banks = '';
foreach ($bank as $value) {
    $banks .= "<option value=$value->accounting_ledger_id>$value->ledger_id</option>";
}

$other = AccountingLedger::find()->where(['account_type_id' => ''])->andWhere(['=', 'group_name_id', ''])->all();
$others = '';
foreach ($other as $value) {
    $others .= "<option value=$value->accounting_ledger_id>$value->ledger_id</option>";
}
// $liabilitys='';
// foreach($liability as $value){
//     $liabilitys.="<option value=$value->accounting_ledger_id>$value->ledger_id</option>";
// }

$settingtypes = GenericTemplate::find()->where(['template_for' => 'Receipt'])->all();
$receiptsettinglist = ArrayHelper::map($settingtypes, 'gt_id', 'template_name');
?>
<style>
    .custDispTbl2 th {
        background: url(../../../images/tblHdrBg.gif) repeat-x scroll left top #0E91BE;
        border: 1px solid #FFF;
        color: #FFFFFF;
        font-size: 0.9em;
        font-weight: bold;
        text-align: center;
        height: 30px;
        vertical-align: middle;
    }

    input[type="text"],
    [type="number"] {
        background-color: #ffffff;
        background-image: none;
        border: 1px solid #e5e6e7;
        border-radius: 1px;
        color: inherit;
        display: block;
        font-size: 14px;
        padding: 6px;
        transition: border-color 0.15s ease-in-out 0s, box-shadow 0.15s ease-in-out 0s;
        width: 100%;
    }

    .select2-container .select2-selection--single {
        height: 38px !important;
    }

    .select2-container--default .select2-selection--single .select2-selection__rendered {
        line-height: 39px;
    }

    .select2-container--default .select2-selection--single .select2-selection__arrow {
        height: 39px;
    }

    body {
        font-family: Arial, Helvetica, sans-serif;
        font-size: 13px;
    }

    .form-control {
        transition: all .2s;
        font-family: Arial, Helvetica, sans-serif;
        font-size: 13px;
    }

    .error-help {
        color: red;
        margin-top: -15px;
    }
</style>
<div class="card no-shadow bg-transparent no-border rm-borders mb-3">
    <div class="card">
        <div class="no-gutters row">
            <div class="col-md-12 col-lg-12">
                <ul class="list-group list-group-flush">
                    <li class="bg-transparent list-group-item">
                        <div class="widget-content p-0">
                            <div class="widget-content-outer">
                                <div class="widget-content-wrapper">
                                    <div class="widget-content-left">
                                        <?php if ($update == 'add') { ?>
                                            <div class="widget-numbers dj-text-success">Create Receipt </div>
                                        <?php } else { ?>
                                            <div class="widget-numbers dj-text-success">Update Receipt </div>
                                        <?php } ?>
                                    </div>
                                    <div class="widget-content-right">
                                        <a href="<?= Url::base(); ?>/users/receipt-details/index" class="dj-danger-btn"><i class="fa fa-chevron-circle-left" aria-hidden="true"></i> Back</a>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </li>

                </ul>
            </div>


        </div>
    </div>
</div>
<div class="main-card mb-3 card">
    <div class="card-body">

        <?php $form = ActiveForm::begin(['options' => ['encrypt' => 'multipart/form-data']]); ?>
        <!-- <form class="dj-sale-receipt-form"> -->
        <div class="form-row">
            <div class="col-md-3">
                <div class="position-relative form-group">
                    <label for="settings type">Settings Type <span class="dj-red">*</span></label>

                    <?php if($model->setting_type=='') { ?>
                            <?= $form->field($model, 'setting_type')->dropDownList($receiptsettinglist, ['class' => 'select_class form-control setting_default', 'prompt' => '--select--'])->label(false) ?>
                           <div class="error-help">This template is already deleted.</div>
                    <?php } else { ?>
                            <?= $form->field($model, 'setting_type')->dropDownList($receiptsettinglist, ['class' => 'select_class form-control', 'prompt' => '--select--'])->label(false) ?>
                            <div class="error-help">This template is already deleted.</div>
                    <?php } ?>    

                    
                </div>
            </div>
            <div class="col-md-3">
                <div class="position-relative form-group">
                    <label for="payment-type">Payment Type<span class="dj-red">*</span></label>
                    <?= $form->field($model, 'payment_type')->dropDownList($payment_types, ['prompt' => '--Select--', 'class' => "select_class form-control payment_type", 'maxlength' => true])->label(false) ?>
                </div>
            </div>


            <div class="col-md-6">
                <div class="position-relative form-group">
                    <label for="Customer Name ">Customer Name<span id="req_span" class="dj-red">*</span></label>


                    <?php if ($model->customer_name != '') { ?>

                        <?php $customer = Customer::find()->where(['id' => $model->customer_name])->one() ?>
                        <?= $form->field($model, 'customer_name')->dropDownList([$model->customer_name => $customer->business_name], ['options' => [$model->customer_name => ['Selected' => 'selected']], 'prompt' => '--Select--', 'class' => "customer form-control", 'maxlength' => true])->label(false) ?>
                    <?php } else { ?>

                        <?= $form->field($model, 'customer_name')->dropDownList([], ['prompt' => '--Select--', 'class' => "form-control customer",])->label(false) ?>
                    <?php } ?>




                </div>
            </div>


            <div class="col-md-6">
                <div class="position-relative form-group">
                    <label for="date" id="receipt_label">Receipt Number Last# <?= $last_entry-1 ?> <span class="dj-red">*</span></label>
                    <div class="form-row">
                        <?php if ($update == 'add') { ?>
                            <div class="col-md-4">

                                <?= $form->field($model, 'receipt_no')->textInput(['maxlength' => true, 'value' => $last_entry, 'readonly' => true])->label(false) ?>

                            </div>
                            <div class="col-md-4">
                                <?= $form->field($model, 'prefix')->textInput(['maxlength' => true, 'value' => 'SR', 'readonly' => true])->label(false) ?>
                            </div>
                            <div class="col-md-4">
                                <?= $form->field($model, 'suffix')->textInput(['maxlength' => true, 'value' => '/'.$dt, 'readonly' => true])->label(false) ?>
                            </div>
                        <?php } else { ?>
                            <div class="col-md-4">

                                <?= $form->field($model, 'receipt_no')->textInput(['maxlength' => true, 'readonly' => true])->label(false) ?>

                            </div>
                            <div class="col-md-4">
                                <?= $form->field($model, 'prefix')->textInput(['maxlength' => true, 'value' => 'SR', 'readonly' => true])->label(false) ?>
                            </div>
                            <div class="col-md-4">
                                <?= $form->field($model, 'suffix')->textInput(['maxlength' => true, 'readonly' => true])->label(false) ?>
                            </div>
                        <?php } ?>

                    </div>
                </div>
            </div>
            <div class="col-md-3">
                <div class="position-relative form-group">
                    <label for="date">Date <span class="dj-red">*</span></label>
                    <?= $form->field($model, 'receipt_date')->textInput(['type' => "date", 'class' => "form-control "])->label(false) ?>
                </div>
            </div>


            <div class="col-md-3">
                <div class="position-relative form-group">
                    <label for="Payment Mode">Payment Mode<span class="dj-red">*</span></label>
                    <?= $form->field($model, 'payment_mode')->dropDownList($payment_modes, ['prompt' => '--Select--', 'class' => "form-control select_class", 'maxlength' => true])->label(false) ?>

                </div>
            </div>
            <div class="col-md-3">
                <div class="position-relative form-group">
                    <label for="Payment Mode">Bank Name</label>
                    <?= $form->field($model, 'bank_name')->dropDownList($banks_name, ['prompt' => '--Select--', 'class' => "select_class form-control", 'maxlength' => true])->label(false) ?>
                </div>
            </div>

            <div class="col-md-3 cheque">
                <div class="position-relative form-group">
                    <label for="cheque no">Cheque No.<span class="dj-red">*</span></label>
                    <?= $form->field($model, 'cheque_no')->textInput(['maxlength' => true])->label(false) ?>
                </div>

            </div>
            <div class="col-md-3 cheque_date">
                <div class="position-relative form-group">
                    <label for="Cheque date">Cheque Date<span class="dj-red">*</span></label>
                    <?= $form->field($model, 'cheque_date')->textInput(['type' => "date", 'class' => "form-control"])->label(false) ?>
                </div>
            </div>


	   <div class="col-md-3 transactions">
                <div class="position-relative form-group">
                    <label for="cheque no">Transaction No.<span class="dj-red">*</span></label>
                    <?= $form->field($model, 'transaction_no')->textInput(['maxlength' => true])->label(false) ?>
                </div>

            </div>
            <div class="col-md-3 transaction_date">
                <div class="position-relative form-group">
                    <label for="Cheque date">Transaction Date<span class="dj-red">*</span></label>
                    <?= $form->field($model, 'transaction_date')->textInput(['type' => "date", 'class' => "form-control"])->label(false) ?>
                </div>
            </div>



            <div class="col-md-3 invoice_amount">
                <div class="position-relative form-group">
                    <label for="Amount">Invoice Amount</label>
                    <?= $form->field($model, 'invoice_amount')->textInput(['maxlength' => true, 'type' => 'number', 'min' => 1, 'step' => .01, 'placeholder' => '0.00', 'readonly' => true, 'class' => 'invoice_amount'])->label(false) ?>
                </div>
            </div>
            <div class="col-md-3 balance">
                <div class="position-relative form-group">
                    <label for="Amount">Balance</label>
                    <?= $form->field($model, 'balance_amount')->textInput(['maxlength' => true, 'type' => 'number', 'min' => 1, 'step' => .01, 'placeholder' => '0.00', 'readonly' => true, 'class' => 'balance_amount'])->label(false) ?>
                </div>
            </div>


            <?php if ($model->payment_type != "Direct Receipt") { ?>
                <div class="col-md-3 amount_ind">
                    <div class="position-relative form-group">
                        <label for="Amount">Amount<span class="dj-red">*</span></label>
                        <?= $form->field($model, 'amount')->textInput(['maxlength' => true, 'type' => 'number', 'min' => 0, 'step' => .01, 'placeholder' => '0.00', 'value' => $update == 'update' ? $model->amount : 0])->label(false) ?>
                    </div>
                </div>
                <div class="col-md-3 tds_amount_ind">
                    <div class="position-relative form-group">
                        <label for="TDS Amount">TDS Amount<span class="dj-red">*</span></label>
                        <?= $form->field($model, 'tds_amount')->textInput(['maxlength' => true, 'type' => 'number','class'=>'form-control tdsamount', 'min' => 0, 'step' => .01, 'placeholder' => '0.00', 'value' => $update == 'update' ? $model->tds_amount : 0])->label(false) ?>
                    </div>
                </div>
            <?php } ?>

            <?php if (!($model->payment_type == "Direct Receipt")) { ?>
                <div class="col-md-3 total_amount_ind">
                    <div class="position-relative form-group">
                        <div class="text-left">
                            <label for="Customer Name ">Total Amount<span class="dj-red">*</span></label>
                            <!-- <div class="widget-numbers dj-text-success">Total:00
                                                                </div> -->
                            <?= $form->field($model, 'total_amount')->textInput(['type' => 'number', 'maxlength' => true, 'readonly' => true, 'step' => .01, 'placeholder' => '0.00', 'value' => $update == 'update' ? $model->total_amount : 0])->label(false) ?>
                        </div>
                    </div>
                </div>
            <?php } ?>



            <div class="col-md-3">
                <div class="position-relative form-group">
                    <label for="Note">Notes</label>

                    <?= $form->field($model, 'notes')->textarea(['rows' => 1])->label(false) ?>
                </div>
            </div>
            <div class="col-md-3">



                <div class="position-relative form-group">
                    <label for="Documents">Attach Documents</label>
                    <?= $form->field($document, 'document_name[]')->fileInput(['maxlength' => true, 'class' => "form-control", 'multiple' => true])->label(false) ?>
                    <label for="ftype">Allowed File Formats *.jpg,*.png, *.GIF,*.txt,*.xls,*docs,*.xlsx(Allowed Size 2m)</label>
                </div>
                <?php if ($update == 'update') { ?>
                    <a class="dj-danger-btn attachments" href=# data-toggle="modal" data-target="#executive_type" value=<?= $_GET['id'] ?>><i class="fa fa-plus-circle" aria-hidden="true"></i> View Attachments</a>
                <?php } ?>
                <!--  <a href="#" class="dj-danger-btn"><i class="fa fa-plus-circle" aria-hidden="true"></i> Add New</a> -->
            </div>
            <div class="col-md-12 form-group" id="showreceipt" style="">

                <?php if ($update != 'add' && $model->payment_type == "Direct Receipt") {
                    $adjustedpayment = DirectReceipt::find()->where(['receipt_id' => $model->id])->all();

                ?>
                    <table id="VoucherTransactionsTable" class="dataTables-example table-striped  table-hover col-tab dataTable table table-bordered no-footer dtr-inline col-sm-12">
                        <thead>
                            <tr>
                                <th class="account" style="width:300px;">Account</th>
                                <th class="amount">Amount</th>
                                <th class="amount">Tax Amount</th>
                                <th class="amount">Total Amount</th>
                                <th class="amount">Cost Centre</th>
                                <th class="id">&nbsp;</th>
                            </tr>
                        </thead>
                        <tbody class="vouchertransactions">

                            <?php foreach ($adjustedpayment as $i => $val) {

                                $incomesi = '';
                                foreach ($income as $value) {
			            $name = str_replace("'", "\'", $value->ledger_id);
                                    if ($val->ledger_id == $value->accounting_ledger_id)
                                        $incomesi .= "<option selected value=\"$value->accounting_ledger_id\">$name</option>";
                                    else
                                        $incomesi .= "<option value=\"$value->accounting_ledger_id\">$name</option>";
                               }



                            ?>
                                <tr class="item transaction">
                                    <td class="account"><select class="form-control select_class required select2-offscreen income firstinc" data-errorrequired="Select Account" name="Products[<?= $i ?>][accountDD]" tabindex="-1" value=<?= $value->ledger_id ?>>
                                            <option value="">Select an Account</option>
                                            <optgroup label="All Accounts"><?= $incomesi ?></optgroup>
                                        </select></td>
                                    <td class="itprice"><input class="form-control required item_price" autocomplete="off" data-errorrequired="Enter Price" pattern="[-0-9.]*" data-error[-0-9.]*="Please enter number only" name="Products[<?= $i ?>][item_price]" min=0 step=.01 placeholder=0.00 type="number" value=<?= $val->price ?>></td>
                                    <td class="ittaxamount"><input class="form-control required tax_amount" autocomplete="off" data-errorrequired="Tax Amount" pattern="[-0-9.]*" data-error[-0-9.]*="Please enter number only" name="Products[<?= $i ?>][tax_amount]" min=0 step=.01 placeholder=0.00 type="number" value=<?= $val->tds_amount ?>></td>
                                    <td class="itamount"><input value=<?= $val->price + $val->tds_amount ?> type=hidden value=0 class=divtotal name="Products[<?= $i ?>][total]">
                                        <div class="divtotal"><?= $val->price + $val->tds_amount ?></div>
                                    </td>
                                    <td><select id="Products_cost_centre" name="Products[<?= $i ?>][cost_centre]" tabindex="-1" class="form-control select2-offscreen">
                                            <option value="">Select Cost Centre</option>
                                        </select></td>
                                    <td class="id"><a class="add-row sm-button add" value="Add" id="btn_addimgV" name="btn_addimgV" href="javascript:void(0)"><i class="fa fa-plus"></i></a></td>
                                </tr>
                            <?php } ?>
                        </tbody>
                        <tfoot>
                            <tr>
                                <td colspan="2">Total:</td>
                                <td class="total" id="totaltaxTxt"><?= $model->tds_amount ?></td>
                                <td class="total" id="totalTxt"><?= $model->total_amount ?></td><input id="taxVal" name="Invoice[taxVal]" type="hidden" value=<?= $model->tds_amount ?>><input name="Invoice[sumTotal]" id="Invoice_sumTotal" type="hidden" value=<?= $model->total_amount ?>>
                            </tr>
                        </tfoot>
                    </table>
                    <?php }
                if ($update != 'add' && $model->payment_type == "Payment Against Invoice") {
                    $adjustedbill = AdjustedInvoices::find()->where(['receipt_id' => $model->id, 'type' => 'invoice'])->all();
                    $more_adjust_bill = Invoice::find()->where(['>','pending_amount',0])->andWhere(['customer_name'=>$model->customer_name])->andwhere(['is_deleted'=>'0'])->all();
                   // if ($adjustedbill) {
                    ?>
                        <h3 style="background: none repeat scroll 0 0 #61A3CB;color: #FFFFFF; padding: 5px;">Pending Bills for the Customer [
                            <?php
                            echo $customer->business_name ?> ]</h3>
                        <table class="custDispTbl2" style="width: 100%;">
                            <thead>
                                <tr>
                                    <th>Entry Type </th>
                                    <th>Entry No # </th>
                                    <th>Amount</th>
                                    <th>Date</th>
                                    <th>Pending</th>
                                    <th>Pay Amount</th>
                                    <th>TDS Amount</th>
                                    <th>Notes</th>
                                    <th>Amount</th>
                                </tr>
                            </thead>
                            <tbody>
                                <?php $totalpending = 0;
                                $paid = 0;
                                $opening = AdjustedInvoices::find()->where(['type' => "opening", 'receipt_id' => $model->id])->one();
                                if ($opening) {
                                    $totalpending = $customer->opening_as_on;
                                ?>
                                    <tr class="newrw">
                                        <td><input type="checkbox" data-pendingamount="<?= $customer->opening_as_on ?>" class="chk_fillamt">Opening</td>
                                        <td></td>
                                        <td><?= $openingtotal ?> </td>
                                        <td><?= date('d-m-y', strtotime($customer->created_at)) ?></td>
                                        <td class="algnrght"><?= $customer->opening_as_on ?></td>
                                        <td style="width:130px"><input type="number" value="<?= $opening->amount_adjusted ?>" data-pendingamount=<?= $customer->opening_as_on ?> name="Bill[0][amount]" id="amount-0" value="0" min=0 step=.01 placeholder=0.00 style="text-align:right;" class="checkPay" alt="0" pattern="[-0-9.]*"></td>
                                        <td style="width:130px"><input type="text" value="<?= $opening->tds_amount ?>" name="Bill[0][tds_amount]" id="tds_amount-0" value="0" style="text-align:right;" class="checkPa" alt="0"></td>
                                        <td><input type="text" value="<?= $opening->notes ?>" name="Bill[0][notes]" id="notes-0" value="" placeholder="Notes"></td>
                                        <td style="width:130px"><input type="text" value="<?= $opening->amount_adjusted ?>" class=indAmount name="Bill[0][totamount]" id="totamount-0" value="0" readonly="readonly" style="text-align:right;"></td><input type="hidden" value="" name="Bill[0][ledger_os_id]"><input type="hidden" id="expense-0" value="" alt="0" name="Bill[0][expenseId]">
                                    </tr>

                                <?php }

                               $count = 0;
                               $added_invs = array();
                              
                                // print_r($adjustedbill); die();
                                foreach ($adjustedbill as $i => $value) {
                                    $bill = Invoice::find()->where(['id' => $value->invoice_id])->one();
                                    $added_invs[] = $bill->id; 
                                    $totalpending += ($bill->pending_amount);
                                    $paid += $value->amount_adjusted; ?>
                                    <tr class="newrw">
                                        <td><input type="checkbox" data-pendingamount="<?= $bill->pending_amount ?>" class="chk_fillamt"><?= $bill->invoice_id ?></td>
                                        <td><?= $bill->id ?></td>
                                        <td><?= $bill->total_price ?> </td>
                                        <td><?= date('d-m-y', strtotime($bill->date)) ?></td>
                                        <td class="algnrght"><?= $bill->pending_amount ?></td>
                                        <td style="width:130px"><input type="number" value="<?= $value->amount_adjusted ?>" name="Bill[<?= $i ?>][amount]" id="amount-<?= $i ?>" value="0" min=0 step=.01 placeholder=0.00 style="text-align:right;" class="checkPay" alt="0" pattern="[-0-9.]*" data-pendingamount=<?= $bill->pending_amount ?>></td>
                                        <td style="width:130px"><input type="text" value="<?= $value->tds_amount ?>" name="Bill[<?= $i ?>][tds_amount]" id="tds_amount-<?= $i ?>" value="0" style="text-align:right;" class="checkPa" alt="0"></td>
                                        <td><input type="text" value="<?= $value->notes ?>" name="Bill[<?= $i ?>][notes]" id="notes-<?= $i ?>" value="" placeholder="Notes"></td>
                                        <td style="width:130px"><input type="text" value="<?= $value->amount_adjusted ?>" class=indAmount name="Bill[<?= $i ?>][totamount]" id="totamount-<?= $i ?>" value="0" readonly="readonly" style="text-align:right;"></td><input type="hidden" value="<?= $value->invoice_id ?>" name="Bill[<?= $i ?>][ledger_os_id]"><input type="hidden" id="expense-<?= $i ?>" value="" alt="0" name="Bill[<?= $i ?>][expenseId]">
                                    </tr>
                                    <?php $count = $count+1; ?>
                                <?php } ?>
                                
                                <?php 
                                //print_r($more_adjust_bill); die();
                                 foreach ($more_adjust_bill as $i => $val) {
                                    //print_r( $value->invoice_id); die();
                                    // $bill = Invoice::find()->where(['id' => $value->invoice_id])->one();
                                    // $added_invs[] = $bill->id; 
                                    $totalpending += ($val->pending_amount);
                                    // $paid += $value->amount_adjusted; ?>
                                    <tr class="newrw">
                                        <td><input type="checkbox" data-pendingamount="<?= $val->pending_amount ?>" class="chk_fillamt"><?= $val->invoice_id ?></td>
                                        <td><?= $val->id ?></td>
                                        <td><?= $val->total_price ?> </td>
                                        <td><?= date('d-m-y', strtotime($val->date)) ?></td>
                                        <td class="algnrght"><?= $val->pending_amount ?></td>
                                        <td style="width:130px"><input type="number"  name="Bill[<?= $count ?>][amount]" id="amount-<?= $count ?>" value="0" min=0 step=.01 placeholder=0.00 style="text-align:right;" class="checkPay" alt="0" pattern="[-0-9.]*" data-pendingamount=<?= $val->pending_amount ?>></td>
                                        <td style="width:130px"><input type="text" name="Bill[<?= $count ?>][tds_amount]" id="tds_amount-<?= $count ?>" value="0" style="text-align:right;" class="checkPa" alt="0"></td>
                                        <td><input type="text" value="" name="Bill[<?= $count ?>][notes]" id="notes-<?= $count ?>" value="" placeholder="Notes"></td>
                                        <td style="width:130px"><input type="text" value="0" class=indAmount name="Bill[<?= $count ?>][totamount]" id="totamount-<?= $count ?>" value="0" readonly="readonly" style="text-align:right;"></td><input type="hidden" value="<?= $val->id ?>" name="Bill[<?= $count ?>][ledger_os_id]"><input type="hidden" id="expense-<?= $count ?>" value="" alt="0" name="Bill[<?= $count ?>][expenseId]">
                                    </tr>
                                    <?php $count = $count+1; ?>
                                <?php } ?>



                                <tr>
                                    <td colspan="8" style="text-align:right;"><b>Amount matched with Bill</b></td>
                                    <td style="text-align:right; width:130px"><input type="text" id="MtotalAmt" name="MtotalAmt" style="text-align:right;" alt="1" readonly="readonly" value=<?= $paid ?>></td>
                                </tr>
                                <tr bgcolor="#E3F0F7">
                                    <td colspan="4" style="text-align:left;"><b>Pending Total:</b> (Rs) "<?= $totalpending ?>"</td>
                                    <td colspan="4" style="text-align:right;"><b>Amount to Customer</b></td>
                                    <td style="width:130px; text-align:right;"><input type="text" id="balanceAmt" name="balanceAmt" value="<?= 0 ?>" style="text-align:right;" alt="1" readonly="readonly"></td>
                                </tr>
                            </tbody>
                        </table>
                <?php // }
                } ?>
            </div>
        </div>

        <div class="djsec-text-right">
            <?= Html::submitButton(($update == "update") ? '<span class="fa fa-file-text-o"></span> Update and Create New' : '<span class="fa fa-file-text-o"></span> Save and Create New', ['class' => 'mb-2 mr-2 btn-icon btn dj-danger-btn submit-btn createon', 'name' => 'save', 'value' => '1']) ?>
            <button class="submit-btn mb-2 mr-2 btn-icon btn dj-danger-btn savewhatsappon"><i class="fa fa-whatsapp" aria-hidden="true"></i> Save and Whatsapp</button>
            <button class="submit-btn mb-2 mr-2 btn-icon btn dj-danger-btn saveemailon"><i class="fa fa-envelope-o" aria-hidden="true"></i> Save and Email</button>

            <?= Html::submitButton(($update == "update") ? '<span class="fa fa-check-square-o"></span> Update' : '<span class="fa fa-check-square-o"></span> Create', ['class' => 'mb-2 mr-2 btn-icon btn dj-danger-btn submit-btn saveon', 'name' => 'save', 'value' => '0']) ?>



            <a href="<?= Url::base(); ?>/users/receipt-details/index" class="mb-2 mr-2 btn-icon btn btn-danger"><i class="fa fa-ban" aria-hidden="true"></i> Cancel</a>

        </div>

        <!-- </form>  -->
        <?php ActiveForm::end(); ?>
    </div>
</div>

<div class="modal fade" id="executive_type">
    <div class="modal-dialog modal-md">

        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="exampleModalLongTitle">Receipt Attachments</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">

                <table id="dinamic">
                    <!-- <tr><td>dd</td></tr> -->
                </table>
            </div>
            <div class="modal-footer">

            </div>
        </div>
    </div>
</div>

<?php ob_start(); ?>
<script>
    $(function() {
        $('.error-help').hide();

        $('.setting_default').find("option[value='18']").attr("selected",true).trigger('change');

        $(document).on("click", ".createon", function(e) {
            // alert();
            e.preventDefault();
            var value = false;
            value = check(value);
            if (value == false) {
                $(this).attr("disabled", "disabled");
                setTimeout(function() {
                    $('.createon').removeAttr("disabled");
                }, 7000);
                $(".createon").submit();
            }
        })
        $(document).on("click", ".saveemailon", function(e) {
            // alert();
            e.preventDefault();
            var value = false;
            value = check(value);
            if (value == false) {
                $(this).attr("disabled", "disabled");
                setTimeout(function() {
                    $('.saveemailon').removeAttr("disabled");
                }, 7000);
                $(".saveemailon").submit();
            }
        })
        $(document).on("click", ".savewhatsappon", function(e) {
            // alert();
            e.preventDefault();
            var value = false;
            value = check(value);
            if (value == false) {
                $(this).attr("disabled", "disabled");
                setTimeout(function() {
                    $('.savewhatsappon').removeAttr("disabled");
                }, 7000);
                $(".savewhatsappon").submit();
            }
        })

        $(document).on("click", ".saveon", function(e) {
             // alert();
            e.preventDefault();
            var value = false;
           
            $('#receiptdetails-setting_type').each(function() {
                var setting = $(this).val();
                // alert(setting);
                $.get('receiptdetailssettingtype', {
                    setting: setting
                }, function(data) {

                    var data = $.parseJSON(data);

                    if (data == '0') {
                        // alert('1');
                        $('#receiptdetails-setting_type').parent().siblings('.error-help').show();
                        $('#receiptdetails-setting_type').focus();

                        value = true;

                    } else {
                        // alert();           
                        $('#receiptdetails-setting_type').parent().siblings('.error-help').hide();
                        value = false;

                    }

                })

            });

             value = check(value);



            if (value == false) {
                $(this).attr("disabled", "disabled");
                setTimeout(function() {
                    $('.saveon').removeAttr("disabled");
                }, 7000);
                // alert();
                $(".saveon").submit();
            }
        })

        function check() {
            // alert('dd');
            var payment_type = $('#receiptdetails-payment_type').val();
            var count = 0;
            // alert(payment_type);
            if (payment_type == 'Direct Receipt') {
                $(".firstinc").each(function() {
                    var val = $(this).val();
                    if (val == '') {
                        //value=true;
                        count = count + 1;
                    } else {
                        // $(".firstinc").css("border","1px solid #ff0000");
                        count = count;
                    }
                })
            } else {
                count = count;
            }
            if (count > 0) {
                value = true;
            } else {
                value = false;
            }

            if (value == true) {
                alert("Please select accounts before submit");
            }
             // alert(value);
            return value;

        }

        $('#req_span').hide();
        // $('.country').select2();
        $('#receiptdetails-payment_type').change(function() {
            if ($(this).val() == 'Direct Receipt') {
                $('#req_span').hide();
            } else {
                $('#req_span').show();
            }
            var customer =  $('#receiptdetails-customer_name').val();
            if(customer){
                alert(customer);
               // $('#receiptdetails-customer_name').val(customer);
                $('#receiptdetails-customer_name').trigger('change');
            }
        });


        <?php if ($update == 'add' && $from == 'saleorder') { ?>
            $cid = $('#receiptdetails-customer_name').val();
            $(document).ready(function() {
               
                $('#receiptdetails-customer_name').trigger('change');
            });
        <?php } else { ?>
            $('#receiptdetails-customer_name').trigger('change');
        <?php } ?>

        <?php if ($from == 'saleorder') { ?>
            var from = 'saleorder';
            var id = <?php echo $id ?>
            // console.log(id);
            // alert(id);
        <?php } else { ?>
            var from = '';
        <?php } ?>
        <?php if ($model->invoice_no != '') { ?>
            $(".invoice_amount").show();
            $(".balance").show();
        <?php } else { ?>
            $(".invoice_amount").hide();
            $(".balance").hide();
        <?php } ?>

        $(document).off('change').on('change', '.chk_fillamt', function() {
            if ($(this).prop('checked')) {
                $(this).attr('data-oldamount', $(this).parent().siblings().children('.checkPay').val())
                $(this).parent().siblings().children('.indAmount ,.checkPay').val($(this).data('pendingamount'));
            } else {
                $(this).parent().siblings().children('.indAmount ,.checkPay').val($(this).attr('data-oldamount'));
            }
            if ($('#receiptdetails-amount').val())
            {
                var diff = parseFloat(isNaN($('#receiptdetails-amount').val()) ? 0 : $('#receiptdetails-amount').val()) - parseFloat(sum());
                if(diff>=0)
                {
                    diff =0;
                }
            }
            else diff = -1 * sum();
            $('#balanceAmt').val(diff);
            $('#MtotalAmt').val(sum())

        })
        $('#receiptdetails-payment_type').change(function() {
            
            var count = $('.vouchertransactions tr').length + 1;
            if ($('#receiptdetails-payment_type').val() == "Direct Receipt") {
                $('#showreceipt').empty();
                $('#showreceipt').append('<table id="VoucherTransactionsTable" class="dataTables-example table-striped  table-hover col-tab dataTable table table-bordered no-footer dtr-inline col-sm-12"><thead><tr><th class="account" style="width:300px;">Account</th><th class="amount">Amount</th><th class="amount">Tax Amount</th><th class="amount">Total Amount</th><th class="amount">Cost Centre</th><th class="id">&nbsp;</th></tr></thead><tbody class="vouchertransactions"><tr class="item transaction"><td class="account"><select class="form-control select_class required select2-offscreen income firstinc" data-errorrequired="Select Account" name="Products[' + count + '][accountDD]" tabindex="-1"><option value="">Select an Account</option><optgroup label="All Accounts"><?= $incomes ?></optgroup> </select></td><td class="itprice"><input class="form-control required item_price" autocomplete="off" data-errorrequired="Enter Price" pattern="[-0-9.]*" data-error[-0-9.]*="Please enter number only" name="Products[' + count + '][item_price]" min=0 step=.01 placeholder=0.00 type="number"></td><td class="ittaxamount"><input class="form-control required tax_amount" autocomplete="off" data-errorrequired="Tax Amount" pattern="[-0-9.]*" data-error[-0-9.]*="Please enter number only" name="Products[' + count + '][tax_amount]" min=0 step=.01 placeholder=0.00 type="number"></td><td class="itamount"><input type=hidden value=0 class=divtotal name=Products[' + count + '][total]><div class="divtotal">0.00</div></td><td><select id="Products_cost_centre" name="Products[' + count + '][cost_centre]" tabindex="-1" class="form-control select2-offscreen"><option value="">Select Cost Centre</option></select></td><td class="id"><a class="add-row sm-button add" value="Add" id="btn_addimgV" name="btn_addimgV" href="javascript:void(0)"><i class="fa fa-plus"></i></a></td></tr></tbody><tfoot><tr><td colspan="2">Total:</td><td class="total" id="totaltaxTxt">0</td><td class="total" id="totalTxt">0</td><input id="taxVal" name="Invoice[taxVal]" type="hidden"><input name="Invoice[sumTotal]" id="Invoice_sumTotal" type="hidden"></tr></tfoot></table>')
                $('.select_class').select2();
                $('.amount_ind').hide();
                $('.tds_amount_ind').hide();
                $('.total_amount_ind').hide();
            } else {
                // $('#showreceipt').empty();
                // $('.amount_ind').show();
                // $('.tds_amount_ind').show();
                // $('.total_amount_ind').show();
            }
        })
        $('#receiptdetails-customer_name').change(function() {
            jQuery.ajaxSetup({
                async: false
            });


            if ($('#receiptdetails-payment_type').val() == "Payment Against Invoice" && from != 'saleorder') {

                $('#showreceipt').empty();
               // $(this).find('option').get(0).remove();

                $.post('pending-invoice', {
                    data: $(this).val()
                }, function(data) {

                    var datadetails = JSON.parse(data)['invoices'];
                    var customer = JSON.parse(data)['customer'];

                    var count = datadetails.length;
                    var i = 0;
                    var dynamic = '';
                    var sum = 0;
                    // console.log(parseFloat(customer['opening_as_on']))
                    if (parseFloat(customer['opening_as_on'])) {
                        sum = parseFloat(customer['opening_as_on']);
                        $.post('pending-opening', {
                            data: $('#receiptdetails-customer_name').val()
                        }, function(data) {

                            var openingtotal = parseFloat(data);
                            dynamic = '<tr class="newrw"><td><input type="checkbox" data-pendingamount=' + customer['opening_as_on'] + ' class="chk_fillamt">Opening</td><td></td><td>' + openingtotal + ' </td><td>' + formatDate(customer['created_at']) + '</td><td class="algnrght">' + customer['opening_as_on'] + '</td><td style="width:130px"><input type="number" value=0 data-pendingamount=' + customer['opening_as_on'] + ' name="Bill[0][amount]" id="amount-0" value="0" min=0 step=.01 placeholder=0.00   style="text-align:right;" class="checkPay" alt="0" pattern="[-0-9.]*"></td><td style="width:130px"><input type="text" value=0 name="Bill[0][tds_amount]" id="tds_amount-0" value="0" style="text-align:right;" class="checkPa" alt="0"></td> <td><input type="text" value="" name="Bill[0][notes]" id="notes-0" value="" placeholder="Notes"></td><td style="width:130px"><input type="text" value=0 class=indAmount name="Bill[0][totamount]" id="totamount-0" value="0" readonly="readonly" style="text-align:right;"></td><input type="hidden" value="" name="Bill[0][ledger_os_id]"><input type="hidden" id="expense-0" value="" alt="0" name="Bill[0][expenseId]"></tr>';
                        })
                    }
                    for (i; i < count; i++) {
                        sum = sum + parseFloat(datadetails[i]['pending_amount']);
                        if (customer['opening_as_on']) {

                            var count1 = i + 1;
                            dynamic += '<tr class="newrw"><td><input type="checkbox" data-pendingamount=' + datadetails[i]['pending_amount'] + ' class="chk_fillamt">' + datadetails[i]['invoice_id'] + ' </td><td>' + datadetails[i]['id'] + '</td><td class="algnrght">' + datadetails[i]['total_price'] + '</td><td>' + formatDate(datadetails[i]['date']) + '</td><td class="algnrght">' + datadetails[i]['pending_amount'] + '</td><td style="width:130px"><input type="number" data-pendingamount=' + datadetails[i]['pending_amount'] + ' name="Bill[' + count1 + '][amount]" id="amount-' + i + '" value="0" min=0 step=.01 placeholder=0.00 style="text-align:right;" class="checkPay" alt="0" pattern="[-0-9.]*"></td><td style="width:130px"><input type="text" name="Bill[' + count1 + '][tds_amount]" id="tds_amount-' + count1 + '" value="0" style="text-align:right;" class="checkPa" alt="0"></td> <td><input type="text" name="Bill[' + count1 + '][notes]" id="notes-' + count1 + '" value="" placeholder="Notes"></td><td style="width:130px"><input type="text" class=indAmount name="Bill[' + count1 + '][totamount]" id="totamount-' + count1 + '" value="0" readonly="readonly" style="text-align:right;"></td><input type="hidden" value="' + datadetails[i]['id'] + '" name="Bill[' + count1 + '][ledger_os_id]"><input type="hidden" id="expense-' + count1 + '" value="" alt="0" name="Bill[' + count1 + '][expenseId]"></tr>'
                        } else
                            dynamic += '<tr class="newrw"><td><input type="checkbox" data-pendingamount=' + datadetails[i]['pending_amount'] + ' class="chk_fillamt">' + datadetails[i]['invoice_id'] + '</td><td>' + datadetails[i]['id'] + ' </td><td class="algnrght">' + datadetails[i]['total_price'] + '</td><td>' + formatDate(datadetails[i]['date']) + '</td><td class="algnrght">' + datadetails[i]['pending_amount'] + '</td><td style="width:130px"><input type="number" data-pendingamount=' + datadetails[i]['pending_amount'] + ' name="Bill[' + i + '][amount]" id="amount-' + i + '" value="0" min=0 step=.01 placeholder=0.00 style="text-align:right;" class="checkPay" alt="0" pattern="[-0-9.]*"></td><td style="width:130px"><input type="text" name="Bill[' + i + '][tds_amount]" id="tds_amount-' + i + '" value="0" style="text-align:right;" class="checkPa" alt="0"></td>  <td><input type="text" name="Bill[' + i + '][notes]" id="notes-' + i + '" value="" placeholder="Notes"></td><td style="width:130px"><input type="text" class=indAmount name="Bill[' + i + '][totamount]" id="totamount-' + i + '" value="0" readonly="readonly" style="text-align:right;"></td><input type="hidden" value="' + datadetails[i]['id'] + '" name="Bill[' + i + '][ledger_os_id]"><input type="hidden" id="expense-' + i + '" value="" alt="0" name="Bill[' + i + '][expenseId]"></tr>'
                    }
                    $('#showreceipt').append('<h3 class=bill-header style="background: none repeat scroll 0 0 #61A3CB;color: #FFFFFF; padding: 5px;">Pending Invoices for the customer  [ ' + $("#receiptdetails-customer_name option:selected").text() + ' ]</h3><table class="custDispTbl2" style="width: 100%;"><thead><tr><th>Entry Type</th><th>Entry No #</th><th>Amount</th><th>Date</th><th>Pending</th><th>Pay Amount</th><th>TDS Amount</th><th>Notes</th><th>Amount</th></tr></thead><tbody>	' + dynamic + '		<tr><td colspan="8" style="text-align:right;"><b>Amount matched with Invoice</b></td><td style="text-align:right; width:130px;"><input type="text" id="MtotalAmt" name="MtotalAmt" value="0" style="text-align:right;" alt="1" readonly="readonly"></td></tr><tr bgcolor="#E3F0F7">		<td colspan="4" style="text-align:left;"><b>Pending Total:</b> (Rs) ' + sum.toFixed(2) + '</td><td colspan="4" style="text-align:right;"><b>Amount to Customer</b></td><td style="text-align:right; width:130px;"><input type="text" id="balanceAmt" name="balanceAmt" value="0" style="text-align:right;" alt="1" readonly="readonly"></td></tr><input type="hidden" name="totalCount" id="totalCount" value="1"><input type="hidden" name="vendorId" value="218733"></tbody></table>')
                })
            } else if ($('#receiptdetails-payment_type').val() == "Payment Against Invoice" && from == 'saleorder') {
                $('#showreceipt').empty();
                $(this).find('option').get(0).remove();
                $.post('pending-saleorder-invoice', {
                    customer: $(this).val(),
                    sale_id: id
                }, function(data) {
                    var datadetails = JSON.parse(data)['invoices'];
                    var customer = JSON.parse(data)['customer'];
                    var count = datadetails.length;
                    var i = 0;
                    var dynamic = '';
                    var sum = 0;
                    // console.log(parseFloat(customer['opening_as_on']))
                    if (parseFloat(customer['opening_as_on'])) {
                        sum = parseFloat(customer['opening_as_on']);
                        $.post('pending-opening', {
                            data: $('#receiptdetails-customer_name').val()
                        }, function(data) {
                            var openingtotal = parseFloat(data);
                            dynamic = '<tr class="newrw"><td><input type="checkbox" data-pendingamount=' + customer['opening_as_on'] + ' class="chk_fillamt">Opening</td><td></td><td>' + openingtotal + ' </td><td>' + formatDate(customer['created_at']) + '</td><td class="algnrght">' + customer['opening_as_on'] + '</td><td style="width:130px"><input type="number" value=0 data-pendingamount=' + customer['opening_as_on'] + ' name="Bill[0][amount]" id="amount-0" value="0" min=0 step=.01 placeholder=0.00  style="text-align:right;" class="checkPay" alt="0" pattern="[-0-9.]*"></td><td style="width:130px"><input type="text" value=0 name="Bill[0][tds_amount]" id="tds_amount-0" value="0" style="text-align:right;" class="checkPa" alt="0"></td> <td><input type="text" value="" name="Bill[0][notes]" id="notes-0" value="" placeholder="Notes"></td><td style="width:130px"><input type="text" value=0 class=indAmount name="Bill[0][totamount]" id="totamount-0" value="0" readonly="readonly" style=" text-align:right;"></td><input type="hidden" value="" name="Bill[0][ledger_os_id]"><input type="hidden" id="expense-0" value="" alt="0" name="Bill[0][expenseId]"></tr>';
                        })
                    }
                    for (i; i < count; i++) {
                        sum = sum + parseFloat(datadetails[i]['pending_amount']);
                        if (customer['opening_as_on']) {
                            var count1 = i + 1;
                            dynamic += '<tr class="newrw"><td><input type="checkbox" data-pendingamount=' + datadetails[i]['pending_amount'] + ' class="chk_fillamt">' + datadetails[i]['invoice_id'] + ' </td><td>' + datadetails[i]['id'] + '</td><td class="algnrght">' + datadetails[i]['total_price'] + '</td><td>' + formatDate(datadetails[i]['date']) + '</td><td class="algnrght">' + datadetails[i]['pending_amount'] + '</td><td style="width:130px"><input type="number" data-pendingamount=' + datadetails[i]['pending_amount'] + ' name="Bill[' + count1 + '][amount]" id="amount-' + i + '" value="0" min=0 step=.01 placeholder=0.00 style="text-align:right;" class="checkPay" alt="0" pattern="[-0-9.]*"></td><td style="width:130px"><input type="text" name="Bill[' + count1 + '][tds_amount]" id="tds_amount-' + count1 + '" value="0" style="text-align:right;" class="checkPa" alt="0"></td> <td><input type="text" name="Bill[' + count1 + '][notes]" id="notes-' + count1 + '" value="" placeholder="Notes"></td><td style="width:130px"><input type="text" class=indAmount name="Bill[' + count1 + '][totamount]" id="totamount-' + count1 + '" value="0" readonly="readonly" style="text-align:right;"></td><input type="hidden" value="' + datadetails[i]['id'] + '" name="Bill[' + count1 + '][ledger_os_id]"><input type="hidden" id="expense-' + count1 + '" value="" alt="0" name="Bill[' + count1 + '][expenseId]"></tr>'
                        } else
                            dynamic += '<tr class="newrw"><td><input type="checkbox" data-pendingamount=' + datadetails[i]['pending_amount'] + ' class="chk_fillamt">' + datadetails[i]['invoice_id'] + '</td><td>' + datadetails[i]['id'] + ' </td><td class="algnrght">' + datadetails[i]['total_price'] + '</td><td>' + formatDate(datadetails[i]['date']) + '</td><td class="algnrght">' + datadetails[i]['pending_amount'] + '</td><td style="width:130px"><input type="number" data-pendingamount=' + datadetails[i]['pending_amount'] + ' name="Bill[' + i + '][amount]" id="amount-' + i + '" value="0" min=0 step=.01 placeholder=0.00 style="text-align:right;" class="checkPay" alt="0" pattern="[-0-9.]*"></td><td style="width:130px"><input type="text" name="Bill[' + i + '][tds_amount]" id="tds_amount-' + i + '" value="0" style="text-align:right;" class="checkPa" alt="0"></td>  <td><input type="text" name="Bill[' + i + '][notes]" id="notes-' + i + '" value="" placeholder="Notes"></td><td style="width:130px"><input type="text" class=indAmount name="Bill[' + i + '][totamount]" id="totamount-' + i + '" value="0" readonly="readonly" style="text-align:right;"></td><input type="hidden" value="' + datadetails[i]['id'] + '" name="Bill[' + i + '][ledger_os_id]"><input type="hidden" id="expense-' + i + '" value="" alt="0" name="Bill[' + i + '][expenseId]"></tr>'
                    }
                    $('#showreceipt').append('<h3 class=bill-header style="background: none repeat scroll 0 0 #61A3CB;color: #FFFFFF; padding: 5px;">Pending Invoices for the customer  [ ' + $("#receiptdetails-customer_name option:selected").text() + ' ]</h3><table class="custDispTbl2" style="width: 100%;"><thead><tr><th>Entry Type</th><th>Entry No #</th><th>Amount</th><th>Date</th><th>Pending</th><th>Pay Amount</th><th>TDS Amount</th><th>Notes</th><th>Amount</th></tr></thead><tbody> ' + dynamic + '   <tr><td colspan="8" style="text-align:right;"><b>Amount matched with Invoice</b></td><td style="text-align:right; width:130px;"><input type="text" id="MtotalAmt" name="MtotalAmt" value="0" style="text-align:right;" alt="1" readonly="readonly"></td></tr><tr bgcolor="#E3F0F7">    <td colspan="4" style="text-align:left;"><b>Pending Total:</b> (Rs) ' + sum.toFixed(2) + '</td><td colspan="4" style="text-align:right;"><b>Amount to Customer</b></td><td style="text-align:right; width:130px;"><input type="text" id="balanceAmt" name="balanceAmt" value="0" style="text-align:right;" alt="1" readonly="readonly"></td></tr><input type="hidden" name="totalCount" id="totalCount" value="1"><input type="hidden" name="vendorId" value="218733"></tbody></table>')
                })
            } else if ($('#receiptdetails-payment_type').val() == "Direct Receipt") {
                $('#custDispTbl2').remove();
                $('.bill-header').remove();

            } else {
                $('#showreceipt').empty();

            }

            $('.invoice_amount').val('');
            $('.balance_amount').val('');
            // $('.payment_type').val(null).trigger('change');
            $('payment_type').trigger('change');
            // $('.payment_type').append('<option value="">--Select--</option>');
            var amt = parseFloat(isNaN($('#receiptdetails-amount').val()) ? 0 : $('#receiptdetails-amount').val());
            $('#balanceAmt').val(amt);
        })
        
        $(document).on('click', '.add-row.sm-button.add', function() {
            var count = $('.vouchertransactions tr').length + 1;
            $('#VoucherTransactionsTable').append('<tr class="item transaction"><td class="account"><select class="form-control select_class' + count + ' required select2-offscreen income firstinc" data-errorrequired="Select Account" name="Products[' + count + '][accountDD]" tabindex="-1"><option value="">Select an Account</option><optgroup label="All Accounts"><?= $incomes ?></optgroup> </select></td><td class="itprice"><input class="form-control required item_price" autocomplete="off" data-errorrequired="Enter Price" pattern="[-0-9.]*" data-error[-0-9.]*="Please enter number only" min=0 step=.01 placeholder=0.00 name="Products[' + count + '][item_price]" type="number"></td><td class="ittaxamount"><input class="form-control required tax_amount" autocomplete="off" data-errorrequired="Tax Amount" pattern="[-0-9.]*" data-error[-0-9.]*="Please enter number only" min=0 step=.01 placeholder=0.00  name="Products[' + count + '][tax_amount]" type="number"></td><td class="itamount"><input type=hidden value=0 class=divtotal name=Products[' + count + '][total]><div class="divtotal">0.00</div></td><td><select id="Products_cost_centre" name="Products[' + count + '][cost_centre]" tabindex="-1" class="form-control select2-offscreen"><option value="">Select Cost Centre</option></select></td><td class="id"><a class="add-row sm-button removeRowBtnV" value="Add"  href="javascript:void(0)"><i class="fa fa-minus"></i></a></td></tr>')
            $('.select_class' + count).select2();
        })
        $(document).on('change', '.item_price', function() {

            totalamount();
            totalind($(this))
        })
        $(document).on('change', '.tax_amount', function() {
            totalamount();
            totalindtax($(this))
        })

        function totalamount() {
            var val = 0;
            var tax = 0
            $('.item_price').each(function() {
                if ($(this).val() && !isNaN($(this).val()))
                    val += parseFloat($(this).val());
            })
            $('.tax_amount').each(function() {
                if ($(this).val() && !isNaN($(this).val()))
                    tax += parseFloat($(this).val());
            })
            $('#totaltaxTxt').text(tax.toFixed(2))
            $('#totalTxt').text((val + tax).toFixed(2))
            $('#taxVal').val(tax.toFixed(2))
            $('#Invoice_sumTotal').val((val + tax).toFixed(2))
        }

        function totalind(value) {
            var val = value.val()
            var tax = value.parent().siblings().children('.tax_amount').val()
            if (!tax && !isNaN(tax))
                tax = 0
            if (!val && !isNaN(val))
                val = 0
            var total = parseFloat(val) + parseFloat(tax);
            value.parent().siblings().children('.divtotal').text((total).toFixed(2)).val((total).toFixed(2))

        }

        function totalindtax(value) {
            var tax = value.val()
            var val = value.parent().siblings().children('.item_price').val()
            if (!tax && !isNaN(tax))
                tax = 0
            if (!val && !isNaN(val))
                val = 0
            var total = parseFloat(val) + parseFloat(tax);
            value.parent().siblings().children('.divtotal').text((total).toFixed(2)).val((total).toFixed(2))

        }
        $(document).on('click', '.removeRowBtnV', function() {
            $(this).parent().parent().remove();
        })
        $(document).on('change', '.checkPay', function() {
            if ($(this).val())
                var val = isNaN($(this).val()) ? 0 : $(this).val();
            else
                val = 0;
            $(this).parent().siblings().children('.indAmount').val($(this).val())
            $('#MtotalAmt').val(sum())
            if ($('#receiptdetails-amount').val())
            {
                var diff = parseFloat(isNaN($('#receiptdetails-amount').val()) ? 0 : $('#receiptdetails-amount').val()) - parseFloat(sum());
                if(diff>=0)
                {
                    diff =0;
                }
            }
            else diff = -1 * sum();
            $('#balanceAmt').val(diff);
        })


        $(document).on('change', '.checkPa', function() {
            if($(this).val() == ''){
                $(this).val(0.00);
            }
            var tdssum = 0;
            $('.checkPa').each(function() {

                if ($(this).val())
                    var val = isNaN($(this).val()) ? 0 : $(this).val();
                else
                    val = 0;
                tdssum = tdssum + parseFloat(val);
                $('.tdsamount').val(tdssum).trigger('change');
            })
            // if ($(this).val())
            //     var val = isNaN($(this).val()) ? 0 : $(this).val();
            // else
            //     val = 0;
            // $(this).parent().siblings().children('.indAmount').val($(this).val())
            // $('#MtotalAmt').val(sum())
            // if ($('#receiptdetails-amount').val())
            //     var diff = parseFloat(isNaN($('#receiptdetails-amount').val()) ? 0 : $('#receiptdetails-amount').val()) - parseFloat(sum());
            // else diff = -1 * sum();
            // $('#balanceAmt').val(diff);



        })


        $('#receiptdetails-amount').change(function() {
            if ($('#receiptdetails-amount').val())
            {
                var diff = parseFloat(isNaN($('#receiptdetails-amount').val()) ? 0 : $('#receiptdetails-amount').val()) - parseFloat(sum());
                if(diff>=0)
                {
                    diff =0;
                }
            }
            else diff = -1 * sum();
            $('#balanceAmt').val(diff);
        })

        function sum() {
            var sum = 0;
            $('.checkPay').each(function() {
                sum = sum + parseFloat($(this).val());
            })
            return sum;
        }

        function formatDate(date) {
            var d = new Date(date),
                month = '' + (d.getMonth() + 1),
                day = '' + d.getDate(),
                year = d.getFullYear();

            if (month.length < 2)
                month = '0' + month;
            if (day.length < 2)
                day = '0' + day;

            return [day, month, year].join('-');
        }

        $('.select_class').select2();
        $('a.receipt-details').click(function() {
            window.location = "<?= Url::base(); ?>/user/receipt-details/create";
        });
        $('#receiptdetails-amount').change(function() {
            $('#receiptdetails-total_amount').val((isNaN($('#receiptdetails-amount').val()) ? 0 : $('#receiptdetails-amount').val()));
        })
        // $('#receiptdetails-tds_amount').change(function(){
        //     $('#receiptdetails-total_amount').val(((isNaN($('#receiptdetails-amount').val())?0:$('#receiptdetails-amount').val())-(isNaN($('#receiptdetails-tds_amount').val())?0:$('#receiptdetails-tds_amount').val())).toFixed(2)); 
        // })
        // $('#receiptdetails-discount').change(function(){
        //     $('#receiptdetails-total_amount').val(((isNaN($('#receiptdetails-amount').val())?0:$('#receiptdetails-amount').val())-(isNaN($('#receiptdetails-tds_amount').val())?0:$('#receiptdetails-tds_amount').val())).toFixed(2)); 
        // }) 
        $('.cheque').hide()
        $('#receiptdetails-payment_mode').change(function() {
            if ($(this).val() == 'Cheque') {
                $('.cheque').show()
            } else {
                $('.cheque').hide()
            }
        })
        $('.cheque_date').hide()
        $('#receiptdetails-payment_mode').change(function() {
            if ($(this).val() == 'Cheque') {
                $('.cheque_date').show()
            } else {
                $('.cheque_date').hide()
            }
        })

        if ($('#receiptdetails-payment_mode').val() == 'Cheque') {
            $('.cheque_date').show();
            $('.cheque').show()
        } else {
            $('.cheque_date').hide();
            $('.cheque').hide();
        }



	$('.transaction').hide()
        $('#receiptdetails-payment_mode').change(function() {
            if ($(this).val() == 'Online Transaction') {
                $('.transactions').show()
            } else {
                $('.transactions').hide()
            }
        })
        $('.transaction_date').hide()
        $('#receiptdetails-payment_mode').change(function() {
            if ($(this).val() == 'Online Transaction') {
                $('.transaction_date').show()
            } else {
                $('.transaction_date').hide()
            }
        })

        if ($('#receiptdetails-payment_mode').val() == 'Online Transaction') {
            $('.transaction_date').show();
            $('.transactions').show()
        } else {
            $('.transaction_date').hide();
            $('.transactions').hide();
        }





        var isLoading = false;
        $('.attachments').click(function() {

            $("#dinamic").empty();
            isLoading = true;
            var id = $(this).attr('value');
            // alert(id);

            $.get('findattachments', {
                id: id
            }, function(data) {
                var data = $.parseJSON(data);
                if (data.length == 0) {
                    $('#dinamic').append("<tr><td  value=''>No Attachments Found</td><tr>");
                }
                for (var i = 0; i < data.length; i++) {
                    // $('#dinamic').append("<tr><td  value='" + data[i].id + "'>" + data[i].document_name + "</td><tr>");

                    $('#dinamic').append("<tr><td  value='" + data[i].id + "'>" + data[i].document_name + "  <i class='fa fa-times deleteattachment' style='color:#FF0000'  aria-hidden='true' data-dismiss='modal' value='" + data[i].id + "'></i></td><tr>");


                }
                $('.deleteattachment').click(function() {
                    var id = $(this).attr('value');
                    // alert(id);
                    $.get('delattachment', {
                        id: id
                    }, function(data) {

                    })

                })
                isLoading = false;

            });
        });


        $('.customer').select2({
            ajax: {
                url: "customer",
                type: "get",
                dataType: 'json',
                delay: 250,
                data: function(params) {
                    return {
                        searchTerm: params.term // search term
                    };
                },
                processResults: function(response) {


                    $('#customersearch').trigger('change');
                    return {
                        results: $.map(response, function(i, item) {

                            return {
                                text: i,
                                slug: "",
                                id: item
                            }
                        })
                    };


                },
                cache: true
            }
        });
        $('form').submit(function(e) {
            if ($("#balanceAmt").length > 0) {
                if ($('#balanceAmt').val() != 0) {
                    if (!$('tr').hasClass('amount-vendor'))
                        $('#balanceAmt').parent().parent().after('<tr class="amount-vendor"><td colspan="8" style="text-align:right;"><p class="help-block">*Amount to customer should be 0.</p></td></tr>')
                    return false;
                } else {
                    $('.amount-vendor').remove();
                }
            }
            $('.submit-btn').prop('disabled', 'true');
            setTimeout(function() {
                if (!$('.has-error').length) {
                    $('.submit-btn').prop('disabled', 'true');
                    $('.submit-btn').text('Please Wait..');
                } else
                    $('.submit-btn').removeAttr('disabled');
            }, 200);
            // $('form').append('<input type="hidden" name="accountcount" value=\"'+$('#dj-table-body tr').length+'\">') 
        })

        $("#receiptdetails-receipt_date").on("change",function(){
        var selected_date = $(this).val();
        var sel_date = new Date($(this).val());
        $.get('selectdate',{selected_date:selected_date},function(data)
        {  

                var d = new Date();
                var output = d.getFullYear() + '-' +'03'+ '-' +'31';

                if(new Date(selected_date) <= new Date(output))
                {
                    var dt = sel_date.getFullYear().toString().substr(-2);
                    var prv_dt = sel_date.getFullYear()-1;
                    var prefix_date = '/'+prv_dt+'-'+dt;
                }
                else
                {
                    var dt = sel_date.getFullYear();
                    var new_dt = (sel_date.getFullYear()+1).toString().substr(-2);
                    var prefix_date = '/'+dt+'-'+new_dt;
                }
                
                var data =$.parseJSON(data);
                $('#receiptdetails-receipt_no').val(data).trigger('change');
                $('#receiptdetails-suffix').val(prefix_date).trigger('change');
                $('#receipt_label').empty();
                $('#receipt_label').append("Receipt Number Last# "+(data-1));

        })
    });



    });
</script>
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean())) ?>
