  <?php

    use yii\helpers\Html;
    use yii\widgets\ActiveForm;
    use yii\helpers\Url;
    use backend\modules\master\models\LeadExecutive;
    use backend\modules\master\models\Customer;
    use backend\modules\master\models\Product;
    use backend\modules\master\models\Category;
    use backend\modules\master\models\Vendor;
    use backend\modules\master\models\ProductUnit;
    use yii\helpers\ArrayHelper;
    use backend\modules\master\models\AccountingTax;
    use backend\modules\master\models\SalesTemplates;
    use backend\modules\master\models\GenericTemplate;

    use backend\models\AuthAssignment;
    use backend\models\AuthItemChild;

    if (date("m") >= 4) {
        $dt = (date('y', strtotime('+0 year'))) . '-' . (date('y', strtotime('+1 year')));
    } else {
        $dt = (date('y', strtotime('-1 year'))) . '-' . (date('y', strtotime('+0 year')));
    }


    $settingtypes = GenericTemplate::find()->where(['template_for' => 'Sales Order'])->all();
    $invsettinglist = ArrayHelper::map($settingtypes, 'gt_id', 'template_name');

    $settingtypesreceipt = GenericTemplate::find()->where(['template_for' => 'Receipt'])->all();
    $receiptsettinglist = ArrayHelper::map($settingtypesreceipt, 'gt_id', 'template_name');

    $id = Yii::$app->user->identity->id;
    $assign = AuthAssignment::find()->where(['user_id' => $id])->one();

    $customer = Customer::find()->select('business_name')->where(['id' => $model->customer_id])->one();
    $tcs_rate = AccountingTax::findOne(35)->tax_rate;
    $current_date = date("d-m-Y");
    /* @var $this yii\web\View */
    /* @var $model backend\modules\users\models\SaleOrder */
    /* @var $form yii\widgets\ActiveForm */
    ?>
  <style>
      .select2-container .select2-selection--single {
          height: 37px !important;
      }

      .select2-container--default .select2-selection--single .select2-selection__rendered {
          line-height: 37px;
      }

      .select2-container--default .select2-selection--single .select2-selection__arrow {
          height: 35px;
      }

      .rendered .select2-selection__rendered {
          width: 144.406px !important;
      }

      body {
          font-family: Arial, Helvetica, sans-serif;
          font-size: 13px;
      }

      .form-control {
          transition: all .2s;
          font-family: Arial, Helvetica, sans-serif;
          font-size: 13px;
      }

      input#saleorder-tcs_amount {
          float: right;
          width: 141px;
          margin-bottom: 25px;
      }
  </style>

  <?php if (Yii::$app->session->hasFlash('success')) { ?>
      <div class="alert alert-success" style="background-color:#dff0d8 !important; text-align:center">
          <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
          <strong style="color:#3c763d"><?= Yii::$app->session->getFlash('success'); ?></strong>
      </div>
  <?php } ?>
  <div class="app-main__inner">
      <div class="card no-shadow bg-transparent no-border rm-borders mb-3">
          <div class="card">
              <div class="no-gutters row">
                  <div class="col-md-12 col-lg-12">
                      <ul class="list-group list-group-flush">
                          <li class="bg-transparent list-group-item">
                              <div class="widget-content p-0">
                                  <div class="widget-content-outer">
                                      <div class="widget-content-wrapper">
                                          <div class="widget-content-left">
                                              <?php if ($update == 'add') { ?>
                                                  <div class="widget-numbers dj-text-success">Create Sales Order</div>
                                              <?php } else { ?>
                                                  <div class="widget-numbers dj-text-success">Update Sales Order</div>
                                              <?php } ?>

                                          </div>
                                          <div class="widget-content-right">
                                              <a href="<?= Url::base(); ?>/users/sale-order/index" class="dj-danger-btn"><i class="fa fa-chevron-circle-left" aria-hidden="true"></i> Back</a>
                                          </div>
                                      </div>
                                  </div>
                              </div>
                          </li>

                      </ul>
                  </div>
              </div>
          </div>
      </div>
      <div class="main-card mb-3 card">
          <div class="card-body">
              <div class="text-right">
                  <!-- <a href="#" class="dj-danger-btn"><i class="fa fa-plus-circle" aria-hidden="true"></i> Add a Customer</a> -->
                  <?php if (AuthItemChild::find()->where(['parent' => $assign->item_name, 'child' => '/master/customer/create'])->one() != '') { ?>
                      <a href="<?= Url::base(); ?>/master/customer/create" target='Blank' class="dj-danger-btn" id="btn-show-modal"><i class="fa fa-plus-circle" aria-hidden="true" onExit="reload"></i> Add a Customer</a>
                  <?php } else { ?>

                  <?php } ?>

                  <?php if (AuthItemChild::find()->where(['parent' => $assign->item_name, 'child' => '/master/lead-executive/create'])->one() != '') { ?>
                      <a href="<?= Url::base(); ?>/master/lead-executive/create" target='Blank' class="dj-danger-btn" id="btn-show-modal"><i class="fa fa-plus-circle" aria-hidden="true" onExit="reload"></i> Add an Executive</a>
                  <?php } else { ?>

                  <?php } ?>


              </div>
              <?php $form = ActiveForm::begin(['options' => ['encrypt' => 'multipart/form-data']]); ?>
              <form class="dj-sale-form">
                  <div class="form-row">
                      <div class="col-md-12">
                          <div class="position-relative form-group">
                              <label for="customer">Settings Type <span class="dj-red">*</span></label>
                              <?php if ($model->setting_type == '') { ?>

                                  <?= $form->field($model, 'setting_type')->dropDownList($invsettinglist, ['class' => 'invsetting form-control select_class setting_default', 'prompt' => '--select--'])->label(false) ?>
                                  <div class="error-help">This template is already deleted.</div>

                              <?php } else { ?>

                                  <?= $form->field($model, 'setting_type')->dropDownList($invsettinglist, ['class' => 'invsetting form-control select_class', 'prompt' => '--select--'])->label(false) ?>
                                  <div class="error-help">This template is already deleted.</div>

                              <?php } ?>

                          </div>
                      </div>
                      <div class="col-md-6">
                          <div class="position-relative form-group">
                              <label for="customer">Customer <span class="dj-red">*</span></label>

                              <?php if ($update == 'update' || ($update == 'add' && ($from == 'leads-quotes' || $from == 'saleorder' || $from == 'leads-enquiry'))) { ?>

                                  <?= $form->field($model, 'customer_id')->dropDownList([$model->customer_id => $customer->business_name], ['options' => [$model->customer_id => ['Selected' => 'selected']], 'prompt' => '--Select--', 'class' => "form-control customer_details", 'id' => 'customersearch'])->label(false) ?>

                              <?php } else { ?>

                                  <?= $form->field($model, 'customer_id')->dropDownList([], ['prompt' => '--Select--', 'class' => "form-control customer_details", 'id' => 'customersearch'])->label(false) ?>

                              <?php } ?>
                              <div class="cst_address">

                                  <label><strong>Address:</strong><br>
                                  </label><br><label for="city"></label>,<label for="address1"></label>,<label for="address2"></label>
                                  <br><label for="address3"></label>,
                                  <label for="state"></label>(<label for="pin"></label>),<label for="country"></label>

                              </div>


                          </div>
                          <div class="position-relative form-group">
                              <label for="executive" class="">Executive </label>
                              <?= $form->field($model, 'executive_id')->dropDownList(ArrayHelper::map(LeadExecutive::find()->select(['name', 'id'])
                                    ->where(['type' => 'Executive'])
                                    ->orderBy('name')
                                    ->asArray()
                                    ->all(), 'id', 'name'), ['prompt' => '--Select--', 'class' => "form-control find_executive",])->label(false) ?>

                          </div>
                      </div>
                      <div class="col-md-6">
                          <div class="position-relative form-group">
                              <label for="notes">Notes</label>
                              <?= $form->field($model, 'note')->textarea(['rows' => 4])->label(false) ?>
                          </div>
                      </div>
                  </div>


                  <div class="form-row">
                      <div class="col-md-6">
                          <div class="position-relative form-group">
                              <label for="gstn">Receiver GSTN/ UID </label>
                              <?= $form->field($model, 'receiver')->textInput([
                                    'maxlength' => true,
                                    'class' => 'form-control customer_gstn'
                                ])->label(false) ?>
                          </div>
                      </div>
                      <div class="col-md-6">
                          <div class="position-relative form-group">
                              <label for="salestype">Sales Type </label>
                              <?= $form->field($model, 'sale_type')->dropDownList($sales_type, ['class' => "sale_type form-control", 'maxlength' => true])->label(false) ?>
                          </div>
                      </div>
                  </div>
                  <hr class="dj-hr">
                  <div class="form-row">
                      <div class="col-md-4">
                          <div class="position-relative form-group">
                              <label for="customer" class="">Supply Type </label>
                              <?= $form->field($model, 'supply_type')->dropDownList($supply_types, ['prompt' => '--Select--', 'class' => "form-control supply_type", 'maxlength' => true])->label(false) ?>
                          </div>
                      </div>
                      <div class="col-md-4">
                          <div class="position-relative form-group">
                              <label for="customer" class="">Supply Attracts Reverse Charge </label>
                              <?= $form->field($model, 'reverse_charge')->dropDownList(['Yes' => 'Yes', 'No' => 'No'], ['class' => 'reverse_charge form-control'])->label(false) ?>
                          </div>
                      </div>

                      <div class="col-md-4">
                          <div class="position-relative form-group">
                              <label for="customer" class="">Priority </label>
                              <?= $form->field($model, 'priority')->dropDownList(['Low' => 'Low', 'High' => 'High'], ['class' => 'priority form-control'])->label(false) ?>
                          </div>
                      </div>
                  </div>
                  <div class="form-row">
                      <div class="col-md-4">
                          <div class="position-relative form-group">
                              <label for="customer" class="">Pricelist </label>
                              <?= $form->field($model, 'price_list')->dropDownList(['Default Price List' => 'Default Price List'], ['class' => '
                                                   form-control price_list'])->label(false) ?>
                          </div>
                      </div>
                      <div class="col-md-4">
                          <div class="position-relative form-group">
                              <label for="customer" class="">PO Number </label>
                              <?= $form->field($model, 'po_no')->textInput(['maxlength' => true])->label(false) ?>
                          </div>
                      </div>
                      <div class="col-md-4">
                          <div class="position-relative form-group">
                              <label for="customer" class="">Additional PO Details</label>
                              <?= $form->field($model, 'po_details')->textInput(['maxlength' => true])->label(false) ?>
                          </div>
                      </div>

                  </div>
                  <div class="form-row">
                      <div class="col-md-6">
                          <div class="position-relative form-group">
                              <label for="customer" class="">Point of Supply (Only if different from location of recipient)</label>

                              <?= $form->field($model, 'point_of_supply')->textInput(['maxlength' => true, 'class' => 'form-control point_of_supply'])->label(false) ?>
                          </div>
                      </div>
                      <div class="col-md-6">
                          <div class="position-relative form-group">
                              <label for="customer" class="">Is tax on this Invoice paid under provisional assessment </label>
                              <?= $form->field($model, 'is_invoice_paid_provisional')->dropDownList(['Yes' => 'Yes', 'No' => 'No'], ['prompt' => '--Select--', 'class' => 'is_invoice_paid_provisional form-control'])->label(false) ?>
                          </div>
                      </div>
                  </div>
                  <div class="form-row">
                      <div class="col-md-6">
                          <div class="position-relative form-group">
                              <label for="podate" class="">PO Dated </label>
                              <?= $form->field($model, 'po_date')->textInput(['maxlength' => true, 'type' => 'date'])->label(false) ?>
                          </div>
                      </div>
                      <div class="col-md-6">
                          <div class="position-relative form-group">
                              <label for="customer" class="">Po Expiry Date </label>
                              <?= $form->field($model, 'po_exp_date')->textInput(['maxlength' => true, 'type' => 'date', 'id' => 'po_exp_date'])->label(false) ?>
                              <div class="error-help">Po Expiry Date is Invalid.</div>
                          </div>
                      </div>
                  </div>
                  <hr class="dj-hr">
                  <h5 class="card-title">Sales Order #</h5>


                  <?php if ($update == 'add') { ?>

                      <div class="form-row">
                          <div class="col-md-4">
                              <div class="position-relative form-group">
                                  <label for="prefix" class="">Prefix</label>
                                  <?= $form->field($model, 'prefix')->textInput(['maxlength' => true, 'value' => 'SO', 'readonly' => true])->label(false) ?>
                              </div>
                          </div>
                          <div class="col-md-4">
                              <div class="position-relative form-group">
                                  <label for="salesorder" class="sale" id="saleorder_label">Sales Order Last# <?= $last_entry - 1 ?></label>
                                  <?= $form->field($model, 'sale_order')->textInput(['maxlength' => true, 'value' => $last_entry, 'readonly' => true])->label(false) ?>
                              </div>
                          </div>
                          <div class="col-md-4">
                              <div class="position-relative form-group">
                                  <label for="suffix" class="">Suffix</label>
                                  <?= $form->field($model, 'suffix')->textInput(['maxlength' => true, 'value' => '/' . $dt, 'readonly' => true])->label(false) ?>
                              </div>
                          </div>
                      </div>

                  <?php } else { ?>

                      <div class="form-row">
                          <div class="col-md-4">
                              <div class="position-relative form-group">
                                  <label for="prefix" class="">Prefix</label>
                                  <?= $form->field($model, 'prefix')->textInput(['maxlength' => true, 'readonly' => true])->label(false) ?>
                              </div>
                          </div>
                          <div class="col-md-4">
                              <div class="position-relative form-group">
                                  <label for="salesorder" class="sale" id="saleorder_label">Sales Order Last#<?= $last_entry - 1 ?></label>
                                  <?= $form->field($model, 'sale_order')->textInput(['maxlength' => true, 'readonly' => true])->label(false) ?>

                              </div>
                          </div>
                          <div class="col-md-4">
                              <div class="position-relative form-group">
                                  <label for="suffix" class="">Suffix</label>
                                  <?= $form->field($model, 'suffix')->textInput(['maxlength' => true, 'readonly' => true, 'value' => '/' . $dt])->label(false) ?>
                              </div>
                          </div>
                      </div>

                  <?php } ?>

                  <div class="form-row">
                      <div class="col-md-6">
                          <div class="position-relative form-group">
                              <label for="date" class="">Date <span class="dj-red">*</span></label>
                              <?php if($model->date=='') { ?>
                                 <?= $form->field($model, 'date')->textInput(['maxlength' => true, 'type' => 'date', 'class' => 'form-control saleorder_date','value'=>date('Y-m-d', strtotime($current_date))])->label(false) ?>
                              <?php  } else { ?>
                                <?= $form->field($model, 'date')->textInput(['maxlength' => true, 'type' => 'date', 'class' => 'form-control saleorder_date'])->label(false) ?>
                              <?php } ?> 
                          </div>
                      </div>
                      <div class="col-md-6">
                          <div class="position-relative form-group">
                              <label for="date" class="">Delivery Date </label>
                              <?= $form->field($model, 'delivery_date')->textInput(['maxlength' => true, 'type' => 'date'])->label(false) ?>
                          </div>
                      </div>

                  </div>
                  <div class="form-row">
                      <div class="col-md-6">
                          <div class="position-relative form-group">
                              <label for="date" class="">Due Date </label>

                              <?= $form->field($model, 'due_date')->textInput(['maxlength' => true, 'type' => 'date', 'class' => 'form-control saleorder_due'])->label(false) ?>
                          </div>
                      </div>
                      <div class="col-md-6">
                          <div class="position-relative form-group">
                              <label for="date" class="">Terms Of Payment</label>

                              <?= $form->field($model, 'terms_of_payment')
                                    ->dropDownList([
                                        'Due upon receipt' => 'Due upon receipt',
                                        'Due within 7 days' => 'Due within 7 days',
                                        'Due within 10 days' => 'Due within 10 days',
                                        'Due within 15 days' => 'Due within 15 days',
                                        'Due within 30 days' => 'Due within 30 days',
                                        'Due within 45 days' => 'Due within 45 days',
                                        'Due within 60 days' => 'Due within 60 days',
                                        'Due within 75 days' => 'Due within 75 days',
                                        'Due within 90 days' => 'Due within 90 days',
                                        'Due within 120 days' => 'Due within 120 days',
                                    ], ['prompt' => '--Select--', 'class' => 'form-control terms_of_payment'])->label(false) ?>
                          </div>
                      </div>
                  </div>

                  <hr class="dj-hr">


                  <div class="form-row">
                      <table class="mb-0 table table-bordered dj-table-form " id="dynamic_field">
                          <thead>
                              <tr width='100%'>
                                  <th colspan="2" width="20%">Product *</th>
                                  <th width="10%">Desc</th>
                                  <th width="10%">Qty</th>
                                  <th width="10%">Units</th>
                                  <th width="10%">Price</th>
                                  <th width="10%">Discount</th>
                                  <th>Discount Type</th>
                                  <th width="20%">Tax</th>
                                  <th>Incl Tax</th>
                                  <th width="10%">Amount</th>
                              </tr>
                          </thead>
                          <tbody id="dj-table-body">
                              <?php if ($update == 'add') { ?>
                                  <?php if ($from != '') { ?>
                                      <?php if (count($saleorderproduct) > 0) { ?>
                                          <?php foreach ($saleorderproduct as $key => $saleorderproduct) : ?>
                                              <?php

                                                $product = Product::find()->select('product_name')->where(['id' => $saleorderproduct->product_id])->one(); ?>
                                              <tr>
                                                  <?php if ($key == 0) { ?>
                                                      <td></td>
                                                  <?php } else { ?>
                                                      <td class="text-center"><i class="fa fa-close removeproduct" aria-hidden="true" style="color: blue;"></i></td>
                                                  <?php } ?>

                                                  <td class="rendered" style="width: 200px">

                                                      <?= $form->field($saleorderproduct, 'product_id')->dropDownList([$saleorderproduct->product_id => $product->product_name], ['options' => [$saleorderproduct->product_id => ['Selected' => 'selected']], 'prompt' => '--Select--', 'class' => "product_details form-control", 'id' => 'product', 'name' => "productdynupdate[$key][product]"])->label(false) ?>
                                                  </td>

                                                  <td>
                                                      <?= $form->field($saleorderproduct, 'description')->textInput(['maxlength' => true, 'id' => 'includedescription', 'class' => "desc form-control", 'name' => "productdynupdate[$key][desc]"])->label(false) ?>
                                                  </td>

                                                  <td>
                                                      <?= $form->field($saleorderproduct, 'quantity')->textInput(['type' => 'number', 'maxlength' => true, 'id' => 'includequantity', 'class' => "product_quantity form-control", 'name' => "productdynupdate[$key][quantity]", 'min' => '1', 'onkeypress' => "return (event.charCode == 8 || event.charCode == 0) ? null : event.charCode >= 48 && event.charCode <= 57"])->label(false) ?>
                                                      <div class="error-help">Quantity cannot be balnk. </div>
                                                  </td>
                                                  <td style="width: 150px">
                                                      <?= $form->field($saleorderproduct, 'units')->dropDownList(['Nos' => 'Nos', 'Pcs' => 'Pcs', 'Pkt' => 'Pkt'], ['maxlength' => true, 'id' => 'includeunits', 'class' => "product_unit form-control", 'name' => "productdynupdate[$key][units]"])->label(false) ?>
                                                  </td>
                                                  <td>
                                                      <?= $form->field($saleorderproduct, 'unit_price')->textInput(['maxlength' => true, 'id' => 'unitprice', 'class' => "unit_price form-control", 'name' => "productdynupdate[$key][unitprice]", 'type' => 'number', 'min' => 0, 'step' => .01, 'placeholder' => '0.00'])->label(false) ?>
                                                      <?= $form->field($saleorderproduct, 'price')->textInput(['maxlength' => true, 'id' => 'includeprice', 'class' => "product_price form-control", 'name' => "productdynupdate[$key][price]", 'type' => 'hidden'])->label(false) ?>
                                                      <div class="error-help">Enter valid price.</div>

                                                  </td>
                                                  <td>
                                                      <?= $form->field($saleorderproduct, 'discount')->textInput(['maxlength' => true, 'id' => 'includediscount', 'class' => "product_discount form-control", 'name' => "productdynupdate[$key][discount]", 'type' => 'number', 'min' => 0, 'step' => .01, 'placeholder' => '0.00'])->label(false) ?>
                                                      <div class="error-help">Discount is not valid.</div>
                                                  </td>
                                                  <td>
                                                      <?= $form->field($saleorderproduct, 'discount_type')->dropDownList(['%' => '%', 'FLAT' => 'FLAT'], ['prompt' => '--Select--', 'class' => ' discount_type form-control', 'id' => 'discounttype', 'name' => "productdynupdate[$key][discounttype]"])->label(false) ?>
                                                      <div class="error-help">Discount Type cannot be blank.</div>
                                                  </td>
                                                  <td>



                                                      <?= $form->field($saleorderproduct, 'tax')->dropDownList(ArrayHelper::map(Accountingtax::find()->select(['tax_rate', 'tax_name'])->asArray()
                                                            ->where(['is_deleted' => 0])
                                                            ->andWhere(['tax_sub_type' => 'Output'])
                                                            ->andWhere(['status' => 1])
                                                            ->andWhere(['or', ['tax_class' => 'IGST'], ['tax_class' => 'TCS']])
                                                            ->all(), 'tax_rate', 'tax_name'), ['prompt' => '--Select Tax--', 'class' => "product_tax form-control ", 'style' => 'width:50px', 'name' => "productdynupdate[$key][tax]", 'id' => 'tax'])->label(false) ?>

                                                      <div class="error-help">Enter Valid tax value.</div>
                                                  </td>

                                                  <td class="text-center">
                                                      <?= $form->field($saleorderproduct, 'tax_included')->checkBox(['label' => '', 'class' => 'product_tax_inc', 'name' => "productdynupdate[$key][tax_included]"]) ?>
                                                  </td>
                                                  <td>
                                                      <?= $form->field($saleorderproduct, 'amount')->textInput(['maxlength' => true, 'readonly' => true, 'id' => 'includeamount', 'class' => "product_amount form-control", 'name' => "productdynupdate[$key][amount]"])->label(false) ?>
                                                      <div class="error-help">Total amount cannot be negative.</div>
                                                  </td>
                                              </tr>
                                          <?php endforeach; ?>
                                      <?php } else { ?>
                                          <tr>
                                              <td></td>
                                              <td class="rendered" style="width: 200px">

                                                  <?= $form->field($saleproduct, 'product_id')->dropDownList([], ['prompt' => '--Select--', 'class' => "product_details form-control", 'id' => 'product', 'name' => 'productdyn[0][product]'])->label(false) ?>

                                              </td>

                                              <td>
                                                  <?= $form->field($saleproduct, 'description')->textInput(['maxlength' => true, 'id' => 'includedescription', 'class' => "desc form-control", 'name' => 'productdyn[0][desc]'])->label(false) ?>
                                              </td>

                                              <td>
                                                  <?= $form->field($saleproduct, 'quantity')->textInput(['type' => 'number', 'maxlength' => true, 'id' => 'includequantity', 'class' => "product_quantity form-control", 'name' => 'productdyn[0][quantity]', 'min' => 1, 'onkeypress' => "return (event.charCode == 8 || event.charCode == 0) ? null : event.charCode >= 48 && event.charCode <= 57"])->label(false) ?>
                                                  <div class="error-help">Quantity cannot be balnk. </div>
                                              </td>
                                              <td>
                                                  <?= $form->field($saleproduct, 'units')->dropDownList(['Nos' => 'Nos', 'Pcs' => 'Pcs', 'Pkt' => 'Pkt'], ['maxlength' => true, 'id' => 'includeunits', 'class' => "product_unit form-control", 'name' => 'productdyn[0][units]'])->label(false) ?>
                                              </td>
                                              <td>
                                                  <?= $form->field($saleproduct, 'unit_price')->textInput(['maxlength' => true, 'id' => 'unitprice', 'class' => "unit_price form-control", 'name' => 'productdyn[0][unitprice]', 'type' => 'number', 'min' => 0, 'step' => .01, 'placeholder' => '0.00'])->label(false) ?>
                                                  <?= $form->field($saleproduct, 'price')->textInput(['maxlength' => true, 'id' => 'includeprice', 'class' => "product_price form-control", 'name' => 'productdyn[0][price]', 'type' => 'hidden'])->label(false) ?>
                                                  <div class="error-help">Enter valid price.</div>

                                              </td>
                                              <td>
                                                  <?= $form->field($saleproduct, 'discount')->textInput(['maxlength' => true, 'id' => 'includediscount', 'class' => "product_discount form-control", 'name' => 'productdyn[0][discount]', 'type' => 'number', 'min' => 0, 'step' => .01, 'placeholder' => '0.00'])->label(false) ?>
                                                  <div class="error-help">Discount is not valid.</div>
                                              </td>
                                              <td>
                                                  <?= $form->field($saleproduct, 'discount_type')->dropDownList(['%' => '%', 'FLAT' => 'FLAT'], ['prompt' => '--Select--', 'class' => ' discount_type form-control', 'id' => 'discounttype', 'name' => 'productdyn[0][discounttype]'])->label(false) ?>
                                                  <div class="error-help">Discount Type cannot be blank.</div>
                                              </td>
                                              <td>

                                                  <?= $form->field($saleproduct, 'tax')->dropDownList(ArrayHelper::map(Accountingtax::find()->select(['tax_rate', 'tax_name'])->asArray()
                                                        ->where(['is_deleted' => 0])
                                                        ->andWhere(['tax_sub_type' => 'Output'])
                                                        ->andWhere(['status' => 1])
                                                        ->andWhere(['or', ['tax_class' => 'IGST'], ['tax_class' => 'TCS']])
                                                        ->all(), 'tax_rate', 'tax_name'), ['prompt' => '--Select Tax--', 'class' => "product_tax form-control ", 'style' => 'width:50px', 'name' => "productdyn[0][tax]", 'id' => 'tax'])->label(false) ?>


                                                  <div class="error-help">Enter tax filled.</div>


                                              </td>

                                              <td class="text-center">
                                                  <?= $form->field($saleproduct, 'tax_included')->checkBox(['label' => '', 'class' => 'product_tax_inc', 'name' => 'productdyn[0][tax_included]']) ?>
                                                  <!-- <div class="error-help">Please enter Tax.</div> -->
                                              </td>
                                              <td>
                                                  <?= $form->field($saleproduct, 'amount')->textInput(['maxlength' => true, 'readonly' => true, 'id' => 'includeamount', 'class' => "product_amount form-control", 'name' => 'productdyn[0][amount]'])->label(false) ?>
                                                  <div class="error-help">Total amount cannot be negative.</div>
                                              </td>
                                          </tr>
                                      <?php } ?>
                                  <?php } else { ?>
                                      <tr>
                                          <td></td>
                                          <td class="rendered" style="width: 200px"><?= $form->field($saleorderproduct, 'product_id')->dropDownList([], ['prompt' => '--Select--', 'class' => "product_details form-control", 'id' => 'product', 'name' => 'productdyn[0][product]'])->label(false) ?>
                                          </td>

                                          <td>
                                              <?= $form->field($saleorderproduct, 'description')->textInput(['maxlength' => true, 'id' => 'includedescription', 'class' => "desc form-control", 'name' => 'productdyn[0][desc]'])->label(false) ?>
                                          </td>

                                          <td>
                                              <?= $form->field($saleorderproduct, 'quantity')->textInput(['type' => 'number', 'maxlength' => true, 'id' => 'includequantity', 'class' => "product_quantity form-control", 'name' => 'productdyn[0][quantity]', 'min' => 1, 'onkeypress' => "return (event.charCode == 8 || event.charCode == 0) ? null : event.charCode >= 48 && event.charCode <= 57"])->label(false) ?>
                                              <div class="error-help">Quantity cannot be balnk. </div>
                                          </td>
                                          <td style="width: 150px">
                                              <?= $form->field($saleorderproduct, 'units')->dropDownList(['Nos' => 'Nos', 'Pcs' => 'Pcs', 'Pkt' => 'Pkt'], ['maxlength' => true, 'id' => 'includeunits', 'class' => "product_unit form-control", 'name' => 'productdyn[0][units]'])->label(false) ?>
                                          </td>
                                          <td>
                                              <?= $form->field($saleorderproduct, 'unit_price')->textInput(['maxlength' => true, 'id' => 'unitprice', 'class' => "unit_price form-control", 'name' => 'productdyn[0][unitprice]', 'type' => 'number', 'min' => 0, 'step' => .01, 'placeholder' => '0.00'])->label(false) ?>
                                              <?= $form->field($saleorderproduct, 'price')->textInput(['maxlength' => true, 'id' => 'includeprice', 'class' => "product_price form-control", 'name' => 'productdyn[0][price]', 'type' => 'hidden'])->label(false) ?>
                                              <div class="error-help">Enter valid price.</div>

                                          </td>
                                          <td>
                                              <?= $form->field($saleorderproduct, 'discount')->textInput(['maxlength' => true, 'id' => 'includediscount', 'class' => "product_discount form-control", 'name' => 'productdyn[0][discount]', 'type' => 'number', 'min' => 0, 'step' => .01, 'placeholder' => '0.00'])->label(false) ?>
                                              <div class="error-help">Discount is not valid.</div>
                                          </td>
                                          <td style="width: 150px">
                                              <?= $form->field($saleorderproduct, 'discount_type')->dropDownList(['%' => '%', 'FLAT' => 'FLAT'], ['prompt' => '--Select--', 'class' => ' discount_type form-control', 'id' => 'discounttype', 'name' => 'productdyn[0][discounttype]'])->label(false) ?>
                                              <div class="error-help">Discount Type cannot be blank.</div>
                                          </td>

                                          <td class="rendered">


                                              <?= $form->field($saleorderproduct, 'tax')->dropDownList(ArrayHelper::map(Accountingtax::find()->select(['tax_rate', 'tax_name'])->asArray()
                                                    ->where(['is_deleted' => 0])
                                                    ->andWhere(['tax_sub_type' => 'Output'])
                                                    ->andWhere(['status' => 1])
                                                    ->andWhere(['or', ['tax_class' => 'IGST'], ['tax_class' => 'TCS']])
                                                    ->all(), 'tax_rate', 'tax_name'), ['prompt' => '--Select Tax--', 'class' => "product_tax form-control ", 'style' => 'width:50px', 'name' => "productdyn[0][tax]", 'id' => 'tax'])->label(false) ?>
                                              <div class="error-help">Enter Valid tax value.</div>
                                          </td>
                                          <td class="text-center">
                                              <?= $form->field($saleorderproduct, 'tax_included')->checkBox(['label' => '', 'class' => 'product_tax_inc', 'name' => 'productdyn[0][tax_included]']) ?>
                                          </td>
                                          <td>
                                              <?= $form->field($saleorderproduct, 'amount')->textInput(['maxlength' => true, 'readonly' => true, 'id' => 'includeamount', 'class' => "product_amount form-control", 'name' => 'productdyn[0][amount]'])->label(false) ?>
                                              <div class="error-help">Total amount cannot be negative.</div>
                                          </td>
                                      </tr>
                                  <?php } ?>

                              <?php } else { ?>
                                  <?php if (count($saleproducts) > 0) {
                                    ?>

                                      <?php foreach ($saleproducts as $key => $saleproducts) : ?>
                                          <?php

                                            $product = Product::find()->select('product_name')->where(['id' => $saleproducts->product_id])->one(); ?>


                                          <tr>
                                              <?php if ($key == 0) { ?>
                                                  <td></td>
                                              <?php } else { ?>
                                                  <td class="text-center"><i class="fa fa-close removeproduct" aria-hidden="true" style="color: blue;"></i></td>
                                              <?php } ?>

                                              <td class="rendered" style="width: 200px">

                                                  <?= $form->field($saleproducts, 'product_id')->dropDownList([$saleproducts->product_id => $product->product_name], ['options' => [$saleproducts->product_id => ['Selected' => 'selected']], 'prompt' => '--Select--', 'class' => "product_details form-control", 'id' => 'product', 'name' => "productdynupdate[$key][product]"])->label(false) ?>


                                              </td>

                                              <td>
                                                  <?= $form->field($saleproducts, 'description')->textInput(['maxlength' => true, 'id' => 'includedescription', 'class' => "desc form-control", 'name' => "productdynupdate[$key][desc]"])->label(false) ?>
                                              </td>

                                              <td>
                                                  <?= $form->field($saleproducts, 'quantity')->textInput(['type' => 'number', 'maxlength' => true, 'id' => 'includequantity', 'class' => "product_quantity form-control", 'name' => "productdynupdate[$key][quantity]", 'min' => '1', 'onkeypress' => "return (event.charCode == 8 || event.charCode == 0) ? null : event.charCode >= 48 && event.charCode <= 57"])->label(false) ?>
                                                  <div class="error-help">Quantity cannot be balnk. </div>
                                              </td>
                                              <td style="width: 150px">
                                                  <?= $form->field($saleproducts, 'units')->dropDownList(['Nos' => 'Nos', 'Pcs' => 'Pcs', 'Pkt' => 'Pkt'], ['maxlength' => true, 'id' => 'includeunits', 'class' => "product_unit form-control", 'name' => "productdynupdate[$key][units]"])->label(false) ?>
                                              </td>
                                              <td>
                                                  <?= $form->field($saleproducts, 'unit_price')->textInput(['maxlength' => true, 'id' => 'unitprice', 'class' => "unit_price form-control", 'name' => "productdynupdate[$key][unitprice]", 'type' => 'number', 'min' => 0, 'step' => .01, 'placeholder' => '0.00'])->label(false) ?>
                                                  <?= $form->field($saleproducts, 'price')->textInput(['maxlength' => true, 'id' => 'includeprice', 'class' => "product_price form-control", 'name' => "productdynupdate[$key][price]", 'type' => 'hidden'])->label(false) ?>
                                                  <div class="error-help">Enter valid price.</div>

                                              </td>
                                              <td>
                                                  <?= $form->field($saleproducts, 'discount')->textInput(['maxlength' => true, 'id' => 'includediscount', 'class' => "product_discount form-control", 'name' => "productdynupdate[$key][discount]", 'type' => 'number', 'min' => 0, 'step' => .01, 'placeholder' => '0.00'])->label(false) ?>
                                                  <div class="error-help">Discount is not valid.</div>
                                              </td>
                                              <td style="width: 150px">
                                                  <?= $form->field($saleproducts, 'discount_type')->dropDownList(['%' => '%', 'FLAT' => 'FLAT'], ['prompt' => '--Select--', 'class' => ' discount_type form-control', 'id' => 'discounttype', 'name' => "productdynupdate[$key][discounttype]"])->label(false) ?>
                                                  <div class="error-help">Discount Type cannot be blank.</div>
                                              </td>
                                              <td>
                                                  <?php

                                                    foreach (explode(',', $saleproducts->tax) as $taxind) {
//						print_r($taxind);
//print_r("polo");
	   $id = AccountingTax::find()->select(['tax_rate'])->where(['accounting_tax_id' => $taxind])->one();
                                                       
                                                        $taxrate= $id['tax_rate'];
                                                        $sel_groups_array[$taxrate] = array("selected" => true);
                                                    }  ?>
                                                  <?= $form->field($saleproducts, 'tax')->dropDownList(ArrayHelper::map(Accountingtax::find()->select(['tax_rate', 'tax_name'])->asArray()
                                                        ->where(['is_deleted' => 0])
                                                        ->andWhere(['tax_sub_type' => 'Output'])
                                                        ->andWhere(['status' => 1])
                                                        ->andWhere(['or', ['tax_class' => 'IGST'], ['tax_class' => 'TCS']])
                                                        ->all(), 'tax_rate', 'tax_name'), ['options' => $sel_groups_array, 'class' => "product_tax form-control", 'style' => 'width:50px', 'name' => "productdynupdate[$key][tax]", 'id' => 'tax'])->label(false) ?>
                                                  <?php $sel_groups_array = [] ?>

                                                  <div class="error-help">Enter Valid tax value.</div>
                                              </td>

                                              <td class="text-center">
                                                  <?= $form->field($saleproducts, 'tax_included')->checkBox(['label' => '', 'class' => 'product_tax_inc', 'name' => "productdynupdate[$key][tax_included]"]) ?>
                                              </td>
                                              <td>
                                                  <?= $form->field($saleproducts, 'amount')->textInput(['maxlength' => true, 'readonly' => true, 'id' => 'includeamount', 'class' => "product_amount form-control", 'name' => "productdynupdate[$key][amount]"])->label(false) ?>
                                                  <div class="error-help">Total amount cannot be negative.</div>
                                              </td>
                                          </tr>


                                      <?php endforeach; ?>
                                  <?php } else { ?>
                                      <tr>

                                          <td></td>
                                          <td class="rendered" style="width: 200px">

                                              <?= $form->field($saleorderproduct, 'product_id')->dropDownList([], ['prompt' => '--Select--', 'class' => "product_details form-control", 'id' => 'product', 'name' => 'productdyn[0][product]'])->label(false) ?>
                                          </td>

                                          <td>
                                              <?= $form->field($saleorderproduct, 'description')->textInput(['maxlength' => true, 'id' => 'includedescription', 'class' => "desc form-control", 'name' => 'productdyn[0][desc]'])->label(false) ?>
                                          </td>

                                          <td>
                                              <?= $form->field($saleorderproduct, 'quantity')->textInput(['type' => 'number', 'maxlength' => true, 'id' => 'includequantity', 'class' => "product_quantity form-control", 'name' => 'productdyn[0][quantity]', 'min' => 1, 'onkeypress' => "return (event.charCode == 8 || event.charCode == 0) ? null : event.charCode >= 48 && event.charCode <= 57"])->label(false) ?>
                                              <div class="error-help">Quantity cannot be balnk. </div>
                                          </td>
                                          <td style="width: 150px">
                                              <?= $form->field($saleorderproduct, 'units')->dropDownList(['Nos' => 'Nos', 'Pcs' => 'Pcs', 'Pkt' => 'Pkt'], ['maxlength' => true, 'id' => 'includeunits', 'class' => "product_unit form-control", 'name' => 'productdyn[0][units]'])->label(false) ?>
                                          </td>
                                          <td>


                                              <?= $form->field($saleorderproduct, 'unit_price')->textInput(['maxlength' => true, 'id' => 'unitprice', 'class' => "unit_price form-control", 'name' => 'productdyn[0][unitprice]', 'type' => 'number', 'min' => 0, 'step' => .01, 'placeholder' => '0.00'])->label(false) ?>
                                              <div class="error-help">Enter valid price.</div>
                                              <?= $form->field($saleorderproduct, 'price')->textInput(['maxlength' => true, 'id' => 'includeprice', 'class' => "product_price form-control", 'name' => 'productdyn[0][price]', 'type' => 'hidden'])->label(false) ?>
                                          </td>
                                          <td>
                                              <?= $form->field($saleorderproduct, 'discount')->textInput(['maxlength' => true, 'id' => 'includediscount', 'class' => "product_discount form-control", 'name' => 'productdyn[0][discount]', 'type' => 'number', 'min' => 0, 'step' => .01, 'placeholder' => '0.00'])->label(false) ?>
                                              <div class="error-help">Discount is not valid.</div>
                                          </td>
                                          <td style="width: 150px">
                                              <?= $form->field($saleorderproduct, 'discount_type')->dropDownList(['%' => '%', 'FLAT' => 'FLAT'], ['prompt' => '--Select--', 'class' => ' discount_type form-control', 'id' => 'discounttype', 'name' => 'productdyn[0][discounttype]'])->label(false) ?>
                                              <div class="error-help">Discount Type cannot be blank.</div>
                                          </td>
                                          <td>

                                              <?= $form->field($saleorderproduct, 'tax')->dropDownList(ArrayHelper::map(Accountingtax::find()->select(['tax_rate', 'tax_name'])->asArray()
                                                    ->where(['is_deleted' => 0])
                                                    ->andWhere(['tax_sub_type' => 'Output'])
                                                    ->andWhere(['status' => 1])
                                                    ->andWhere(['or', ['tax_class' => 'IGST'], ['tax_class' => 'TCS']])
                                                    ->all(), 'tax_rate', 'tax_name'), ['prompt' => '--Select Tax--', 'class' => "product_tax form-control ", 'style' => 'width:50px', "name" => 'productdyn[0][tax]', 'id' => 'tax'])->label(false) ?>

                                              <div class="error-help">Enter Valid tax value.</div>
                                          </td>

                                          <td class="text-center">
                                              <?= $form->field($saleorderproduct, 'tax_included')->checkBox(['label' => '', 'class' => 'product_tax_inc', 'name' => 'productdyn[0][tax_included]']) ?>
                                          </td>
                                          <td>
                                              <?= $form->field($saleorderproduct, 'amount')->textInput(['maxlength' => true, 'readonly' => true, 'id' => 'includeamount', 'class' => "product_amount form-control", 'name' => 'productdyn[0][amount]'])->label(false) ?>
                                              <div class="error-help">Total amount cannot be negative.</div>
                                          </td>
                                      </tr>
                                  <?php } ?>
                              <?php } ?>
                          </tbody>
                      </table>
                  </div>
                  <div class="form-row">
                      <table class="mb-0 table table-bordered">
                          <tr>
                              <td width="25%" rowspan="7"><?= Html::Button(' <i class="fa fa-plus-circle" aria-hidden="true"></i> Add a Line', ['class' => 'dj-danger-btn', 'id' => "add_new"]) ?></td>
                              <td width="25%" rowspan="7" class="text-right">


                                  <?php if (AuthItemChild::find()->where(['parent' => $assign->item_name, 'child' => '/master/product/create'])->one() != '') { ?>

                                      <a href="<?= Url::base(); ?>/master/product/create" target='Blank' class="dj-danger-btn"><i class="fa fa-plus-circle" aria-hidden="true"></i> Add a Product</a>

                                  <?php } else { ?>

                                  <?php } ?>
                              </td>
                              <td width="25%"><label class="dj-sub-total-amt">Subtotal:</label></td>
                              <td width="25%" class="text-right">
                                  <label class="subtotalamt dj-sub-total-amt" style="padding-top: 10px">0.00</label><?= $form->field($model, 'sub_total_amount')->hiddenInput(['maxlength' => true, 'readonly' => true, 'class' => "form-control subtotal"])->label(false) ?>
                                  <div class="error-help">Sub Total cannot be negative.</div>
                              </td>

                          </tr>
                          <!-- <tr>
                                            <td><label class="dj-sub-total-amt">Add: Round Off</label></td>
                                            <td><input name="desc" id="desc" type="text" class="form-control"></td>
                                          </tr> -->

                          <!-- <div class="sale_order_intrastate"> -->
                          <?php if ($update == 'add') { ?>
                              <tr>

                                  <td class="sale_order_intrastate"><label class="dj-total-amt">CGST:</label></td>
                                  <td width="25%" class="text-right sale_order_intrastate">
                                      <label class="cgstvalue dj-total-amt" style="padding-top: 10px">0.00</label><?= $form->field($model, 'cgst_amount')->hiddenInput(['maxlength' => true, 'class' => "form-control cgst"])->label(false) ?>

                                  </td>
                              </tr>
                              <tr>
                                  <td class="sale_order_intrastate"><label class="dj-total-amt">SGST:</label></td>
                                  <td width="25%" class="text-right sale_order_intrastate">
                                      <label class="sgstvalue dj-total-amt" style="padding-top: 10px">0.00</label><?= $form->field($model, 'sgst_amount')->hiddenInput(['maxlength' => true, 'class' => "form-control sgst"])->label(false) ?>

                                  </td>
                              </tr>
                          <?php } else { ?>

                              <tr>
                                  <td class="gst_on_update"><label class="dj-total-amt">CGST:</label></td>
                                  <td width="25%" class="text-right gst_on_update">
                                      <label class="cgstvalue dj-total-amt" style="padding-top: 10px">0.00</label><?= $form->field($model, 'cgst_amount')->hiddenInput(['maxlength' => true, 'class' => "form-control cgst"])->label(false) ?>

                                  </td>
                              </tr>
                              <tr>
                                  <td class="gst_on_update"><label class="dj-total-amt">SGST:</label></td>
                                  <td width="25%" class="text-right gst_on_update">
                                      <label class="sgstvalue dj-total-amt" style="padding-top: 10px">0.00</label><?= $form->field($model, 'sgst_amount')->hiddenInput(['maxlength' => true, 'class' => "form-control sgst"])->label(false) ?>

                                  </td>
                              </tr>

                          <?php } ?>
                          <!-- </div> -->

                          <tr>
                              <?php if ($update == 'add') { ?>
                                  <td class="sale_order_interstate"><label class="dj-total-amt">IGST:</label></td>
                                  <td width="25%" class="text-right sale_order_interstate"><label class="totaligst dj-total-amt" style="padding-top: 10px">0.00</label>
                                      <?= $form->field($model, 'igst_amount')->hiddenInput(['maxlength' => true, 'class' => "form-control total_igst"])->label(false) ?>
                                  </td>
                              <?php } else { ?>

                                  <td class="igst_on_update"><label class="dj-total-amt ">IGST:</label></td>
                                  <td width="25%" class="text-right igst_on_update"><label class="totaligst dj-total-amt" style="padding-top: 10px">0.00</label>
                                      <?= $form->field($model, 'igst_amount')->hiddenInput(['maxlength' => true, 'class' => "form-control total_igst"])->label(false) ?>
                                  </td>
                              <?php } ?>
                          </tr>
                          <tr>


                              <td width="25%"><label class="dj-sub-total-amt"><?= $form->field($model, 'is_tcs')->checkBox(['label' => '', 'class' => 'tcs_tax'])->label(false) ?></label>&nbsp;&nbsp;<label class="dj-sub-total-amt">TCS:</label></td>
                              <td width="25%" class="text-right"><label class="dj-sub-total-amt tcsam" style="padding-top: 10px"></label><?= $form->field($model, 'tcs_amount')->textInput(['maxlength' => true, 'class' => "form-control tcsamount"])->label(false) ?>
                              </td>
                          </tr>
                          <tr>
                              <td><input type="checkbox" id="round" type="text" class="">&nbsp;&nbsp;<label class="dj-sub-total-amt">Add: Round Off</label></td>
                              <td><input readonly name="roundoffval" id="roundoffval" type="text" class="form-control" value=<?= $model->round_off ? $model->round_off : '' ?>></td>
                          </tr>
                          <tr>
                              <td><label class="dj-total-amt">Total(INR):</label></td>
                              <td width="25%" class="text-right">
                                  <label class="totalamt dj-total-amt" style="padding-top: 10px">0.00</label>
                                  <?= $form->field($model, 'total_amount')->hiddenInput(['maxlength' => true, 'class' => "form-control totalamount"])->label(false) ?>
                                  <div class="error-help">Total cannot be negative.</div>
                              </td>

                          </tr>


                          <tr>
                              <td colspan="2">
                                  <!--  -->
                                  <?= $form->field($model, 'advance_payment')->radioList(['Advance payment for this Sales Order' => 'Allow Advance payment for this Sales Order', 'Matched Receipt' => 'Match Receipt', 'None' => 'None'])->label(false); ?>
                              </td>
                          </tr>
                      </table>

                  </div>


                  <?php if ($model->advance_payment == "Advance payment for this Sales Order") { ?>
                      <hr class="dj-hr after_advance_line">
                      <div class="form-row after_advance_payment">
                          <div class="col-md-12">
                              <div class="dj-other-heading">Advance Payment Datails</div>
                          </div>
                          <div class="col-md-6 setting">
                              <div class="position-relative form-group ">
                                  <label for="settings type">Settings Type </label>
                                  <?= $form->field($model, 'receipt_setting_type')->dropDownList(['Inv Receipt' => 'Inv Receipt'], ['prompt' => '--Select--', 'class' => "receipt_setting_type form-control", 'maxlength' => true])->label(false) ?>
                              </div>
                          </div>
                          <div class="col-md-6 receipt_amt">
                              <div class="position-relative form-group">
                                  <label>Amount(Rs.) </label>
                                  <?= $form->field($model, 'receipt_total_amount')->textInput(['maxlength' => true, 'type' => 'number', 'id' => 'receipt_total_amount', 'min' => 0, 'step' => .01, 'placeholder' => '0.00'])->label(false) ?>
                                  <div class="error-help">Receipt Total Amount cannot be negative.</div>
                              </div>
                          </div>
                          <div class="col-md-6 receipt_bank">
                              <div class="position-relative form-group">
                                  <label>Bank </label>
                                  <?= $form->field($model, 'receipt_bank')->dropDownList($banks_name, ['prompt' => '--Select--', 'class' => "res_bank form-control", 'maxlength' => true])->label(false) ?>
                              </div>
                          </div>
                          <div class="col-md-6 cheque">
                              <div class="position-relative form-group">
                                  <label for="cheque no">Cheque No. </label>
                                  <?= $form->field($model, 'receipt_cheque_no')->textInput(['maxlength' => true])->label(false) ?>
                              </div>

                          </div>
                          <div class="col-md-6 cheque_date">
                              <div class="position-relative form-group">
                                  <label for="Cheque date">Cheque Date</label>
                                  <?= $form->field($model, 'receipt_cheque_date')->textInput(['type' => "date", 'class' => "form-control", 'id' => 'receipt_cheque_date'])->label(false) ?>
                                  <div class="error-help">Receipt Cheque Date is invalid.</div>
                              </div>
                          </div>
                          <div class="col-md-6 receipt_nt">
                              <div class="position-relative form-group">
                                  <label>Advance Note </label>
                                  <?= $form->field($model, 'advance_note')->textarea(['maxlength' => true, 'rows' => 1])->label(false) ?>
                              </div>
                          </div>
                      </div>
                  <?php } else { ?>
                      <hr class="dj-hr line">
                      <div class="form-row advance">
                          <div class="col-md-12 heading">
                              <div class="dj-other-heading">Advance Payment Datails</div>
                          </div>
                          <div class="col-md-6 setting">
                              <div class="position-relative form-group ">
                                  <label for="settings type">Settings Type </label>

                                  <?= $form->field($model, 'receipt_setting_type')->dropDownList($receiptsettinglist, ['prompt' => '--Select--', 'class' => "receipt_setting_type form-control", 'maxlength' => true])->label(false) ?>
                              </div>
                          </div>
                          <div class="col-md-6 receipt_amt">
                              <div class="position-relative form-group">
                                  <label>Amount(Rs.) </label>
                                  <?= $form->field($model, 'receipt_total_amount')->textInput(['maxlength' => true, 'type' => 'number', 'id' => 'receipt_total_amount', 'min' => 0, 'step' => .01, 'placeholder' => '0.00'])->label(false) ?>
                                  <div class="error-help">Receipt Total Amount cannot be negative.</div>
                              </div>
                          </div>
                          <div class="col-md-6 receipt_bank">
                              <div class="position-relative form-group">
                                  <label>Bank </label>
                                  <?= $form->field($model, 'receipt_bank')->dropDownList($banks_name, ['prompt' => '--Select--', 'class' => "res_bank form-control", 'maxlength' => true])->label(false) ?>
                              </div>
                          </div>
                          <div class="col-md-6 cheque">
                              <div class="position-relative form-group">
                                  <label for="cheque no">Cheque No. </label>
                                  <?= $form->field($model, 'receipt_cheque_no')->textInput(['maxlength' => true])->label(false) ?>
                              </div>

                          </div>
                          <div class="col-md-6 cheque_date">
                              <div class="position-relative form-group">
                                  <label for="Cheque date">Cheque Date</label>
                                  <?= $form->field($model, 'receipt_cheque_date')->textInput(['type' => "date", 'class' => "form-control", 'id' => 'receipt_cheque_date'])->label(false) ?>
                                  <div class="error-help">Receipt Cheque Date is invalid.</div>
                              </div>
                          </div>
                          <div class="col-md-6 receipt_nt">
                              <div class="position-relative form-group">
                                  <label>Advance Note </label>
                                  <?= $form->field($model, 'advance_note')->textarea(['maxlength' => true, 'rows' => 1])->label(false) ?>
                              </div>
                          </div>
                      </div>
                  <?php } ?>
                  <?php if ($model->advance_payment == "Matched Receipt") { ?>
                      <hr class="dj-hr after_match">
                      <div class="form-row after_matchreceipt">
                          <div class="col-md-12">
                              <div class="dj-other-heading">Match Existing Receipt</div>
                          </div>

                          <div class="col-md-6 receipt_nt">
                              <div class="position-relative form-group">
                                  <label>Receipt Id </label>
                                  <?= $form->field($model, 'receipt_id')->textInput(['maxlength' => true, 'class' => "form-control receipt_id"])->label(false) ?>
                                  <div class="error-help">Enter a valid receipt id.</div>
                              </div>
                          </div>
                      </div>
                  <?php } else { ?>
                      <hr class="dj-hr match">
                      <div class="form-row advance_matchreceipt">
                          <div class="col-md-12 match_heading">
                              <div class="dj-other-heading">Match Existing Receipt</div>
                          </div>

                          <div class="col-md-6 receipt_nt">
                              <div class="position-relative form-group">
                                  <label>Receipt Id </label>
                                  <?= $form->field($model, 'receipt_id')->textInput(['maxlength' => true, 'class' => "form-control receipt_id"])->label(false) ?>
                                  <div class="error-help">Enter a valid receipt id.</div>
                              </div>
                          </div>
                      </div>
                  <?php } ?>

                  <hr class="dj-hr">
                  <div class="form-row">
                      <div class="col-md-12">
                          <div class="dj-other-heading">Other Details</div>
                      </div>
                  </div>

                  <div class="form-row">

                      <div class="col-md-12">
                          <div class="position-relative form-group">
                              <label for="notes" class="">Note</label>

                              <?= $form->field($model, 'other_note')->textarea(['rows' => 4])->label(false) ?>
                          </div>
                      </div>
                  </div>
                  <hr class="dj-hr">
                  <div class="form-row">
                      <div class="col-md-6">
                          <div class="position-relative form-group">
                              <label for="exampleFile" class="">Attach Documents</label>
                              <?= $form->field($saleorderdocument, 'document_name[]')->fileInput(['maxlength' => true, 'class' => "form-control", 'multiple' => true])->label(false) ?>
                              <span class="form-text text-muted">Allowed File Formats *.jpg,*.png,*.gif,*.txt,*.xls,*.doc,*.xlsx (Allowed Size 2M)</span>
                          </div>

                          <?php if ($update == 'add') { ?>
                          <?php } else { ?>
                              <a class="dj-danger-btn attachments" href=# data-toggle="modal" data-target="#attachemnts_find" value=<?= $_GET['id'] ?>><i class="fa fa-plus-circle" aria-hidden="true"></i> View Attachments</a>
                          <?php } ?>

                      </div>
                      <div class="col-md-6">
                          <div class="position-relative form-group">
                              <label for="notes" class="">Terms</label>
                              <?= $form->field($model, 'terms')->textarea(['rows' => 4])->label(false) ?>
                          </div>
                      </div>
                  </div>
                  <div class="djsec-text-right dj-btn-sapce-sec">
                      <?= Html::submitButton(($update == "update") ? '<span class="fa fa-file-text-o"></span> Update and Create New' : '<span class="fa fa-file-text-o"></span> Save and Create New', ['class' => 'mb-2 mr-2 btn-icon btn dj-danger-btn createon', 'name' => 'save', 'value' => '1']) ?>
                      <button class="mb-2 mr-2 btn-icon btn dj-danger-btn save_whatsapp"><i class="fa fa-whatsapp" aria-hidden="true"></i> Save and Whatsapp</button>
                      <button class="mb-2 mr-2 btn-icon btn dj-danger-btn save_email"><i class="fa fa-envelope-o" aria-hidden="true"></i> Save and Email</button>
                      <?= Html::submitButton(($update == "update") ? '<span class="fa fa-check-square-o"></span> Update' : '<span class="fa fa-check-square-o"></span> Create', ['class' => 'mb-2 mr-2 btn-icon btn dj-danger-btn saveon', 'name' => 'save', 'value' => '0']) ?>
                      <a href="<?= Url::base(); ?>/users/sale-order/index" class="mb-2 mr-2 btn-icon btn btn-danger"><i class="fa fa-ban" aria-hidden="true"></i> Cancel</a>

                  </div>
              </form>
              <?php ActiveForm::end(); ?>
          </div>
      </div>
  </div>

  <div class="modal fade" id="attachemnts_find">
      <div class="modal-dialog modal-md">

          <div class="modal-content">
              <div class="modal-header">
                  <h5 class="modal-title" id="exampleModalLongTitle">Receipt Attachments</h5>
                  <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                      <span aria-hidden="true">&times;</span>
                  </button>
              </div>
              <div class="modal-body">
                  <table id="dinamic">
                  </table>
              </div>
              <div class="modal-footer">

              </div>
          </div>
      </div>
  </div>
  <?php ob_start(); ?>
  <script>
      $(document).on('select2:open', () => {
          document.querySelector('.select2-search__field').focus();
      });
      $(document).ready(function() {
          total();
          subtotal();
          $('.setting_default').find("option[value='11']").attr("selected", true).trigger('change');
          $('.select_class').select2();
          <?php if ($update == 'add' && $from == 'leads-enquiry') { ?>
              var customerid = $(".customer_details").val();
              customerchange(customerid);

          <?php } ?>
          <?php if ($update == 'update') { ?>
              // $(".product_tax").select2().select2('val','34');
              $(".product_tax").trigger('change');

          <?php } ?>
          $('.cst_address').hide();
          if ($('.customer_details').val() != '') {
              var customerid = $('.customer_details').val();
              $('.cst_address').show();
              $.get('../leads-quotes/findcustomerdetails', {
                  customerid: customerid
              }, function(data) {
                  var data = $.parseJSON(data);
                  $("label[for='address1']").html(data.adderss_line_1);
                  $("label[for='address2']").html(data.adderss_line_2);
                  $("label[for='address3']").html(data.adderss_line_3);
                  $("label[for='city']").html(data.city);
                  $("label[for='state']").html(data.state);
                  $("label[for='pin']").html(data.pin_code);
                  $("label[for='country']").html(data.country);
              })
          } else {
              $('.cst_address').hide();
              $("label[for='address1']").html('');
              $("label[for='address2']").html('');
              $("label[for='address3']").html('');
              $("label[for='city']").html('');
              $("label[for='state']").html('');
              $("label[for='pin']").html('');
              $("label[for='country']").html('');
          }


          $('.sale_order_intrastate').hide();
          $('.sale_order_interstate').hide();
          if ($('.point_of_supply').val() == 21) {
              $('.sale_order_intrastate').show();
              $('.sale_order_interstate').hide();
              $('.igst_on_update').hide();
              $('.gst_on_update').show();
          } else if ($('.point_of_supply').val() == '') {
              $('.sale_order_interstate').hide();
              $('.sale_order_intrastate').hide();
              $('.igst_on_update').hide();
              $('.gst_on_update').hide();
          } else {
              $('.sale_order_interstate').show();
              $('.sale_order_intrastate').hide();
              $('.igst_on_update').show();
              $('.gst_on_update').hide();
          }
          $('.point_of_supply').change(function() {
              if ($(this).val() == 21) {
                  $('.sale_order_intrastate').show();
                  $('.sale_order_interstate').hide();
                  $('.igst_on_update').hide();
                  $('.gst_on_update').show();
              } else {
                  $('.sale_order_interstate').show();
                  $('.sale_order_intrastate').hide();
                  $('.igst_on_update').show();
                  $('.gst_on_update').hide();
              }
          })

          $('#customersearch').select2({
              ajax: {
                  url: "customerdetails",
                  type: "get",
                  dataType: 'json',
                  delay: 250,
                  data: function(params) {
                      return {
                          searchTerm: params.term // search term
                      };
                  },
                  processResults: function(response) {


                      $('#customersearch').trigger('change');
                      return {
                          results: $.map(response, function(i, item) {

                              return {
                                  text: i,
                                  slug: "",
                                  id: item
                              }
                          })
                      };


                  },
                  cache: true
              }
          });


          $('.find_executive').select2();
          $('.priority').select2();
          $('.supply_type').select2();
          $('.product_unit').select2();
          $('.sale_type').select2();
          $('.reverse_charge').select2();
          $('.is_invoice_paid_provisional').select2();
          $('.terms_of_payment').select2();
          $('.price_list').select2();
          $('.find_executive').select2();
          $('.product_details').select2({
              ajax: {
                  url: '../leads-quotes/productdetails',
                  type: "get",
                  dataType: 'json',
                  delay: 250,
                  theme: "classic",
                  data: function(params) {
                      return {
                          searchTerm: params.term // search term
                      };
                  },
                  processResults: function(response) {

                      return {
                          results: $.map(response, function(i, item) {

                              return {
                                  text: i,
                                  slug: "",
                                  id: item
                              }
                          })
                      };


                  },
                  cache: true
              }
          });
          $('.product_tax').select2();
          $('.discount_type').select2();
          // $('.product_unit').select2();
          $('.res_bank').select2();
          $('.receipt_setting_type').select2();
          var receipt_check = true;
          $('.receipt_id').change(function() {
              if ($(this).val() != '') {
                  var receiptid = $(this).val();
                  var customer = $('.customer_details').val();
                  $.get('checkreceipt', {
                      receiptid: receiptid,
                      customer: customer
                  }, function(data) {
                      if (data == 'true') {
                          receipt_check = true;
                          $('.receipt_id').parent().siblings('.error-help').hide();
                      } else if (data == 'false') {
                          receipt_check = false;
                          $('.receipt_id').parent().siblings('.error-help').show();
                      }
                  })

              }
          })

          $(document).on('click', ".removeproduct", function() {
              $(this).parent().parent().remove();
              var $this = $(this);
              $this.parent().parent().siblings().children().children('.desc').val('');
              $this.parent().parent().siblings().children().children('.product_price').val('');
              $this.parent().parent().siblings().children().children('.unit_price').val('');
              $this.parent().parent().siblings().children().children('.product_tax').val('');
              $this.parent().parent().siblings().children().children('.product_unit').val('').trigger('change');
              $this.parent().parent().siblings().children().children('.product_quantity').val('');
              $this.parent().parent().siblings().children().children('.product_discount').val('');
              $this.parent().parent().siblings().children().children('.discount_type').val('');
              $this.parent().parent().siblings().children().children('.product_amount').val('');

              subtotal();
              total();
          });
          $('.customer_details').change(function() {
              var customerid = $(this).val();
              customerchange(customerid);


          });


          function customerchange(customerid = null) {
              if (customerid != '') {
                  $('.cst_address').show();
                  $.get('../leads-quotes/findcustomerdetails', {
                      customerid: customerid
                  }, function(data) {
                      var data = $.parseJSON(data);


                      $("label[for='address1']").html(data.adderss_line_1);
                      $("label[for='address2']").html(data.adderss_line_2);
                      $("label[for='address3']").html(data.adderss_line_3);
                      $("label[for='city']").html(data.city);
                      $("label[for='state']").html(data.state);
                      $("label[for='pin']").html(data.pin_code);
                      $("label[for='country']").html(data.country);
                      var due = 0;
                      if (data.credit_terms != '') {
                          if (data.credit_terms == 'Due within 7 days') {
                              due = 7;
                          }
                          if (data.credit_terms == 'Due within 10 days') {
                              due = 10;
                          }
                          if (data.credit_terms == 'Due within 15 days') {
                              due = 15;
                          }
                          if (data.credit_terms == 'Due within 30 days') {
                              due = 30;
                          }
                          if (data.credit_terms == 'Due within 45 days') {
                              due = 45;
                          }
                          if (data.credit_terms == 'Due within 60 days') {
                              due = 60;
                          }
                          if (data.credit_terms == 'Due within 75 days') {
                              due = 75;
                          }
                          if (data.credit_terms == 'Due within 90 days') {
                              due = 90;
                          }
                          if (data.credit_terms == 'Due within 120 days') {
                              due = 120;
                          }

                      }
                      var date = new Date($('.saleorder_date').val());
                      if (date != '') {
                          date.setDate(date.getDate() + due);
                          var day = ("0" + date.getDate()).slice(-2);
                          var month = ("0" + (date.getMonth() + 1)).slice(-2);
                          var dt = date.getFullYear() + "-" + (month) + "-" + (day);
                          $('.saleorder_due').val(dt).trigger('change');
                          if (data.credit_terms == 'Due upon receipt') {
                              $('.saleorder_due').val(dt).trigger('change');
                          }
                      } else {
                          $('.saleorder_due').val('');
                      }

                      $('.customer_gstn').val(data.gstin_no);
                      $('.terms_of_payment').val(data.credit_terms).trigger('change');
                      if ($('.customer_gstn').val() != '') {
                          $('.sale_type').val('B2B').trigger('change');
                          var gstin_value = data.gstin_no;
                          var state_code = gstin_value.substr(0, 2);
                          $('.point_of_supply').val(state_code).trigger('change');
                          if (state_code == 21) {
                              $('.supply_type').val('Intra-State').trigger('change');
                          } else {
                              $('.supply_type').val('Inter-State').trigger('change');
                          }
                      } else {
                          $('.sale_type').val('B2C').trigger('change');
                          $('.point_of_supply').val('21').trigger('change');
                          $('.supply_type').val('Intra-State').trigger('change');
                      }
                      $('.executive').val('').trigger('change');
                      var executivedata = data.executive;
                      if (executivedata != '') {
                          $.get('findexecutivedetails', {
                              executivedata: executivedata
                          }, function(data) {
                              var executivedetail = $.parseJSON(data);
                              $('.find_executive').val(executivedetail.id).trigger('change');
                          })
                      } else {
                          $('.find_executive').val('').trigger('change');
                      }
                  })
              } else {
                  $('.cst_address').hide();
                  $("label[for='address1']").html('');
                  $("label[for='address2']").html('');
                  $("label[for='address3']").html('');
                  $("label[for='city']").html('');
                  $("label[for='state']").html('');
                  $("label[for='pin']").html('');
                  $("label[for='country']").html('');

                  $('.customer_gstn').val('');
                  $('.point_of_supply').val('').trigger('change');
                  $('.supply_type').val('').trigger('change');
                  $('.find_executive').val('').trigger('change');
              }
          }


          $('.customer_gstn').change(function() {
              var gst_no = $(this).val();
              var s_code = gst_no.substr(0, 2);
              if (gst_no != '') {
                  $('.sale_type').val('B2B').trigger('change');
              } else {
                  $('.sale_type').val('B2C').trigger('change');
              }
              $('.point_of_supply').val(s_code).trigger('change');
              if (s_code == 21) {
                  $('.supply_type').val('Intra-State').trigger('change');
              } else {
                  $('.supply_type').val('Inter-State').trigger('change');
              }

          })
          $('.point_of_supply').change(function() {
              var state_no = $(this).val();
              if (state_no == 21) {
                  $('.supply_type').val('Intra-State').trigger('change');
              } else {
                  $('.supply_type').val('Inter-State').trigger('change');
              }

          })
          $('.saleorder_date').change(function() {
              var due = 0;
              if ($('.terms_of_payment').val() != '') {
                  if ($('.terms_of_payment').val() == 'Due within 7 days') {
                      due = 7;
                  }
                  if ($('.terms_of_payment').val() == 'Due within 10 days') {
                      due = 10;
                  }
                  if ($('.terms_of_payment').val() == 'Due within 15 days') {
                      due = 15;
                  }
                  if ($('.terms_of_payment').val() == 'Due within 30 days') {
                      due = 30;
                  }
                  if ($('.terms_of_payment').val() == 'Due within 45 days') {
                      due = 45;
                  }
                  if ($('.terms_of_payment').val() == 'Due within 60 days') {
                      due = 60;
                  }
                  if ($('.terms_of_payment').val() == 'Due within 75 days') {
                      due = 75;
                  }
                  if ($('.terms_of_payment').val() == 'Due within 90 days') {
                      due = 90;
                  }
                  if ($('.terms_of_payment').val() == 'Due within 120 days') {
                      due = 120;
                  }
              }
              var date = new Date($('.saleorder_date').val());
              if (date != '') {
                  date.setDate(date.getDate() + due);
                  var day = ("0" + date.getDate()).slice(-2);
                  var month = ("0" + (date.getMonth() + 1)).slice(-2);
                  var dt = date.getFullYear() + "-" + (month) + "-" + (day);
                  $('.saleorder_due').val(dt).trigger('change');
                  if ($('.terms_of_payment').val() == 'Due upon receipt') {
                      $('.saleorder_due').val(dt).trigger('change');
                  }
              } 
              else {
                  $('.saleorder_due').val('');
              }
          });
          $('.terms_of_payment').change(function() {
              var due = 0;
              if ($(this).val() != '') {
                  if ($(this).val() == 'Due within 7 days') {
                      due = 7;
                  }
                  if ($(this).val() == 'Due within 10 days') {
                      due = 10;
                  }
                  if ($(this).val() == 'Due within 15 days') {
                      due = 15;
                  }
                  if ($(this).val() == 'Due within 30 days') {
                      due = 30;
                  }
                  if ($(this).val() == 'Due within 45 days') {
                      due = 45;
                  }
                  if ($(this).val() == 'Due within 60 days') {
                      due = 60;
                  }
                  if ($(this).val() == 'Due within 75 days') {
                      due = 75;
                  }
                  if ($(this).val() == 'Due within 90 days') {
                      due = 90;
                  }
                  if ($(this).val() == 'Due within 120 days') {
                      due = 120;
                  }
              }
              var date = new Date($('.saleorder_date').val());
              if (date != '') {
                  date.setDate(date.getDate() + due);
                  var day = ("0" + date.getDate()).slice(-2);
                  var month = ("0" + (date.getMonth() + 1)).slice(-2);
                  var dt = date.getFullYear() + "-" + (month) + "-" + (day);
                  $('.saleorder_due').val(dt).trigger('change');
                  if ($(this).val() == 'Due upon receipt') {
                      $('.saleorder_due').val(dt).trigger('change');
                  }
              } else {
                  $('.saleorder_due').val('');
              }
          })

          // $('.customer_details').change(function()

          var po_exp_date_check = false;
          $("#po_exp_date").change(function() {
              po_exp_date_check = true;
          })
          var receipt_cheque_date_check = false;
          $("#receipt_cheque_date").change(function() {
              receipt_cheque_date_check = true;
          })
          var receipt_total_amount_check = false;
          $("#receipt_total_amount").change(function() {
              receipt_total_amount_check = true;
          })


          $('.error-help').hide();
          $(document).on("click", ".saveon", function(e) {
              e.preventDefault();
              var value = false;

              value = validateform(value);

              if (value == false) {

                  $(this).attr("disabled", "disabled");
                  $('.save_whatsapp').attr("disabled", "disabled");
                  $('.save_email').attr("disabled", "disabled");
                  $('.createon').attr("disabled", "disabled");
                  setTimeout(function() {
                      $('.saveon').removeAttr("disabled");
                      $('.save_whatsapp').removeAttr("disabled");
                      $('.save_email').removeAttr("disabled");
                      $('.createon').removeAttr("disabled");
                  }, 7000);
                  $("#w0").submit();
              }
          });

          $(document).on("click", ".save_whatsapp", function(e) {
              e.preventDefault();
              var value = false;

              value = validateform(value);

              if (value == false) {

                  $(this).attr("disabled", "disabled");
                  $('.saveon').attr("disabled", "disabled");
                  $('.save_email').attr("disabled", "disabled");
                  $('.createon').attr("disabled", "disabled");
                  setTimeout(function() {
                      $('.saveon').removeAttr("disabled");
                      $('.save_whatsapp').removeAttr("disabled");
                      $('.save_email').removeAttr("disabled");
                      $('.createon').removeAttr("disabled");
                  }, 7000);
                  $(".save_whatsapp").submit();
              }
          });

          $(document).on("click", ".save_email", function(e) {
              e.preventDefault();
              var value = false;

              value = validateform(value);

              if (value == false) {

                  $(this).attr("disabled", "disabled");
                  $('.save_whatsapp').attr("disabled", "disabled");
                  $('.saveon').attr("disabled", "disabled");
                  $('.createon').attr("disabled", "disabled");
                  setTimeout(function() {
                      $('.saveon').removeAttr("disabled");
                      $('.save_whatsapp').removeAttr("disabled");
                      $('.save_email').removeAttr("disabled");
                      $('.createon').removeAttr("disabled");
                  }, 7000);
                  $(".save_email").submit();
              }
          });

          $(document).on("click", ".createon", function(e) {
              e.preventDefault();
              var value = false;

              value = validateform(value);

              if (value == false) {

                  $(this).attr("disabled", "disabled");
                  $('.save_whatsapp').attr("disabled", "disabled");
                  $('.saveon').attr("disabled", "disabled");
                  $('.save_email').attr("disabled", "disabled");
                  setTimeout(function() {
                      $('.saveon').removeAttr("disabled");
                      $('.save_whatsapp').removeAttr("disabled");
                      $('.save_email').removeAttr("disabled");
                      $('.createon').removeAttr("disabled");
                  }, 7000);
                  $(".createon").submit();
              }
          });


          function validateform(value) {
              var product_count = 0;
              $(".product_amount").each(function() {
                  if ($(this).val() != '' && $(this).val() != 0) {
                      product_count = product_count + 1;
                  }
              })
              if (product_count == 0) {
                  value = true;
                  alert("Atleast add one product to create a sale order");
                  $('.product_details').focus();
              }
              $('.receipt_id').each(function() {
                  var advance_payment = $('input[name="SaleOrder[advance_payment]"]:checked').val();
                  if ($('input[name="SaleOrder[advance_payment]"]:checked').val() == 'Matched Receipt' && receipt_check == false) {
                      value = true;
                      $('.receipt_id').focus();
                  }
              })


              $("#receipt_cheque_date").each(function() {
                  var receipt_cheque_date = $('#receipt_cheque_date').val();
                  var advance_payment = $('input[name="SaleOrder[advance_payment]"]:checked').val();
                  if ($('input[name="SaleOrder[advance_payment]"]:checked').val() == 'Advance payment for this Sales Order' && receipt_cheque_date_check == true) {
                      if (Date.parse(receipt_cheque_date)) {
                          // alert('valid');
                          $(this).parent().siblings('.error-help').hide();

                      } else {
                          // alert('invalid');
                          $(this).parent().siblings('.error-help').show();
                          value = true;
                          $(this).focus();
                      }
                  }
              })
              $('#receipt_total_amount').each(function() {
                  var receipt_total_amount = $('#receipt_total_amount').val();
                  if (receipt_total_amount_check == true) {
                      if (receipt_total_amount < 0 && $('input[name="SaleOrder[advance_payment]"]:checked').val() == 'Advance payment for this Sales Order') {

                          value = true;
                          $(this).parent().siblings('.error-help').show();
                          $(this).focus();

                      } else {
                          $(this).parent().siblings('.error-help').hide();
                      }
                  }
              })
              $("#po_exp_date").each(function() {
                  var po_exp_date = $('#po_exp_date').val();
                  if (po_exp_date_check == true) {
                      if (Date.parse(po_exp_date)) {
                          $(this).parent().siblings('.error-help').hide();
                      } else {
                          value = true;
                          $(this).parent().siblings('.error-help').show();
                          $(this).focus();
                      }
                  }
              })

              //     $(".product_discount").each(function()
              //    // $(document).on("each",".discount",function()
              //     {
              //         if($(this).val()!="" && $(this).val()>=0)
              //         {
              //             var discounttype = $(this).parent().parent().siblings().children().children('.discount_type').val();
              //             if(discounttype == null || discounttype == '' || discounttype == '--Select--')
              //             {
              //                 value=true;
              //                 $(this).parent().parent().siblings().children('.error-help').show();
              //                 $(this).parent().parent().siblings().children().children('.error-help').show();
              //                 $(this).parent().parent().siblings().children().children('.discount_type').focus();
              //             }
              //             else      
              //             {
              //                 $(this).parent().parent().siblings().children('.error-help').hide();
              //                 $(this).parent().parent().siblings().children().children('.error-help').hide();
              //             }
              //         }
              //         else
              //         {  
              //             if($(this).val()!=0 && $(this).val()!="" && $(this).val()<0)
              //             {
              //                 $(this).parent().siblings('.error-help').show();
              //                 $(this).focus();
              //             }
              //             else
              //             {
              //                 $(this).parent().siblings('.error-help').hide();
              //             }

              //             $(this).parent().parent().siblings().children('.error-help').hide();
              //             $(this).parent().parent().siblings().children().children('.error-help').hide();
              //         }
              //     });
              // $(".discount_type").each(function()
              // {
              //     if($(this).val()=='FLAT' || $(this).val()=='%')
              //     {
              //         var discount = $(this).parent().parent().siblings().children().children('.product_discount').val();
              //         if(discount=='')
              //         {
              //              value=true;
              //              $(this).parent().parent().siblings().children('.error-help').show();
              //              $(this).parent().parent().siblings().children().children('.product_discount').focus();
              //         }
              //         else
              //         {
              //              $(this).parent().parent().siblings().children('.error-help').hide();
              //         }
              //     }
              // });
              $(".product_amount").each(function() {
                  if ($(this).val() < 0) {
                      $(this).parent().siblings('.error-help').show();
                      value = true;
                      $(this).focus();
                  } else {
                      $(this).parent().siblings('.error-help').hide();
                  }
              })
              $(".totalamount").each(function() {
                  if ($(this).val() < 0) {
                      $(this).siblings('.help-block').text("Total cannot be negative");
                      // $(this).parent().siblings('.error-help').show();
                      value = true;
                  } else {
                      $(this).siblings('.help-block').text("");
                  }
              })
              $(".subtotal").each(function() {
                  if ($(this).val() < 0) {
                      $(this).parent().siblings('.error-help').show();
                      value = true;
                  } else {
                      $(this).parent().siblings('.error-help').hide();
                  }
              })
              $(".unit_price").each(function() {
                  if (($(this).val() <= 0 || !$(this).val().match(/^\s*\d*\.?\d{0,2}\s*$/)) && $(this).val() != '') {
                      $(this).parent().siblings('.error-help').show();
                      value = true;
                      $(this).focus();
                  } else {
                      $(this).parent().siblings('.error-help').hide();
                  }
              })
              $(".product_quantity").each(function() {
                  if ($(this).val() <= 0 && $(this).val() != "") {
                      value = true;
                      $(this).parent().siblings('.error-help').show();
                      $(this).siblings('.error-help').show();
                      $(this).focus();
                  } else {
                      $(this).parent().siblings('.error-help').hide();
                      $(this).siblings('.error-help').hide();

                  }
              });

              $('.product_tax').each(function() {
                  var inc_check = $(this).parent().parent().siblings().children().children().children('input[class="product_tax_inc"]:checked').val();
                  // alert($(this).val());
                  //alert($(this).val());
                  if (inc_check == 1 && $(this).val() == "") {
                      value = true;
                      $(this).focus();
                      $(this).parent().siblings('.error-help').show();

                  } else {
                      $(this).parent().siblings('.error-help').hide();
                  }
              })
              return value;
          }


          $(document).on("change", ".unit_price", function() {
              if ($(this).val() > 0) {
                  $(this).parent().siblings('.error-help').hide();
              } else {
                  $(this).parent().siblings('.error-help').show();
              }
              var $this = $(this);
              $this.parent().siblings().children('.product_price').val((((isNaN($(this).val()) ? 0 : $(this).val()) * ((isNaN($this.parent().parent().siblings().children().children('.product_quantity').val()) ? 1 : $this.parent().parent().siblings().children().children('.product_quantity').val())))));
            
              subtotal();
              total();
          });
          $(document).on("change", ".product_quantity", function() {
              if ($(this).val() > 0) {
                  $(this).parent().siblings('.error-help').hide();
              } else {
                  $(this).parent().siblings('.error-help').show();
              }
              var $this = $(this);
              $this.parent().parent().siblings().children().children('.product_price').val((((isNaN($this.parent().parent().siblings().children().children('.unit_price').val()) ? 0 : $this.parent().parent().siblings().children().children('.unit_price').val()) * ((isNaN($(this).val()) ? 1 : $(this).val())))));
              subtotal();
              total();
          });
          $(document).on("change", ".product_discount", function() {
              var $this = $(this);
             
              if ($(this).val() > 0 || $(this).val() == 0) {
                  $(this).parent().siblings('.error-help').hide();
              } else {
                  $(this).parent().siblings('.error-help').show();
              }
              subtotal();
              total();
          });
          $(document).on("change", ".discount_type", function() {
              $(this).parent().siblings('.error-help').hide();
              var $this = $(this);
            subtotal();
            total();
          });
          $(document).on("change", ".product_tax", function() {
           //   alert("checking");
              var $this = $(this);
              subtotal();
              total();
           
          })
          $(document).on("change", ".product_tax_inc", function() {

              taxIncluded($(this))
          })

          function taxIncluded(val) {
           //   alert('second checking');
              var $this = val;
              subtotal();
              total();
          }

          $(document).on("change", ".product_details", function() {

              jQuery.ajaxSetup({
                  async: false
              });
              var $this = $(this);
              if ($(this).val() == '') {
                  $this.parent().parent().siblings().children().children('.desc').val('');
                  $this.parent().parent().siblings().children().children('.product_price').val('');
                  $this.parent().parent().siblings().children().children('.unit_price').val('');
                  $this.parent().parent().siblings().children().children('.product_tax').val('');
                  $this.parent().parent().siblings().children().children('.product_unit').val('').trigger('change');
                  $this.parent().parent().siblings().children().children('.product_quantity').val('');
                  $this.parent().parent().siblings().children().children('.product_discount').val(0);
                  // $this.parent().parent().siblings().children().children('.discount_type').val('').trigger('change');
                  $this.parent().parent().siblings().children().children('.product_amount').val('');
                  $this.parent().parent().siblings().children().children().children('input[class="product_tax_inc"]:checked').prop('checked', false);
                  subtotal();
                  total();
              }
              var productid = $(this).val();


              $.get('findproduct', {
                  productid: productid
              }, function(data) {
                  var data = $.parseJSON(data);
                  alert('Stock Available: ' + data.stock_unit);
                  $this.parent().parent().siblings().children().children('.desc').val(data.category);
                  $this.parent().parent().siblings().children().children('.product_price').val(data.selling_price);
                  $this.parent().parent().siblings().children().children('.unit_price').val(data.selling_price);
                  $this.parent().parent().siblings().children().children('.product_unit').find("option[value='" + data.units + "']").attr("selected", true).trigger('change');
                  var item = data.selling_tax_rate;
                  var tax = 0;
                  $.get('../leads-quotes/taxdetails', {
                      item: item
                  }, function(data) {
                      var data = $.parseJSON(data);
                      tax = (data.tax_rate);
                  })
                //   alert(tax);
                //   alert("inside product");
                  $this.parent().parent().siblings().children().children('.product_tax').find('option').removeAttr("selected");
                  // if(tax_details)
                  // {
                  //     alert(tax_details);
                  //     tax_details.split(',').forEach(function(item) {
                  //     $this.parent().parent().siblings().children().children('.product_tax').find("option[value='"+item+"']").attr("selected",true);
                  //     $this.parent().parent().siblings().children().children('.product_tax').trigger('change.select2');
                  //     });
                  // }
                  if (tax) {


                      $this.parent().parent().siblings().children().children('.product_tax').find("option[value='" + tax + "']").attr("selected", true);
                      $this.parent().parent().siblings().children().children('.product_tax').trigger('change.select2');

                  } else {
                      $this.parent().parent().siblings().children().children('.product_tax').find("option[value='0.000']").attr("selected", true).trigger('change.select2');
                  }
                  // $this.parent().parent().siblings().children().children('.product_tax').find("option[value='37']").attr("selected",true).trigger('change');
                  // $this.parent().parent().siblings().children().children('.product_tax').trigger('change.select2');
                  $this.parent().parent().siblings().children().children('.product_quantity').val(1);
                  $this.parent().parent().siblings().children().children('.product_discount').val('0.00');
                  //alert($this.parent().parent().siblings().children().children('.product_discount').val());
                  // $this.parent().parent().siblings().children().children('.discount_type').find("option[value='%']").attr("selected",true).trigger('change');
                 // $this.parent().parent().siblings().children().children().children('input[class="product_tax_inc"]:checked').prop('checked', true);
                  var value = $this.parent().parent().siblings().children().children().children('input[class="product_tax_inc"]:checked').val();
                  if (value == 1) {
                      var amt = (($this.parent().parent().siblings().children().children('.unit_price').val() * $this.parent().parent().siblings().children().children('.product_quantity').val()) + (($this.parent().parent().siblings().children().children('.unit_price').val() * $this.parent().parent().siblings().children().children('.product_quantity').val()) * $this.parent().parent().siblings().children().children('.product_tax').val()) / 100);
                  } else {
                      var amt = $this.parent().parent().siblings().children().children('.unit_price').val() * $this.parent().parent().siblings().children().children('.product_quantity').val();
                  }
                  $this.parent().parent().siblings().children().children('.product_amount').val(amt);

              });
              if ($(this).val()) {
                  var tax = $(this).parent().parent().siblings().children().children('.product_tax').val();
                  if (tax != '') {
                     // $(this).parent().parent().siblings().children().children('label').children('.product_tax_inc').prop('checked', true);




                      var $this = $(this).parent().parent().siblings().children().children('label').children('.product_tax_inc');
                      if ($this.parent().parent().parent().siblings().children().children('.discount_type').val() == '%') {
                          $this.parent().parent().parent().siblings().children().children('.product_amount').val((((isNaN($this.parent().parent().parent().siblings().children().children('.unit_price').val()) ? 0 : $this.parent().parent().parent().siblings().children().children('.unit_price').val()) * ((isNaN($this.parent().parent().parent().siblings().children().children('.product_quantity').val()) ? 1 : $this.parent().parent().parent().siblings().children().children('.product_quantity').val()))) - ((((isNaN($this.parent().parent().parent().siblings().children().children('.unit_price').val()) ? 0 : $this.parent().parent().parent().siblings().children().children('.unit_price').val()) * ((isNaN($this.parent().parent().parent().siblings().children().children('.product_quantity').val()) ? 1 : $this.parent().parent().parent().siblings().children().children('.product_quantity').val()))) * (isNaN($this.parent().parent().parent().siblings().children().children('.product_discount').val()) ? 0 : $this.parent().parent().parent().siblings().children().children('.product_discount').val())) / 100)));
                      } else if ($this.parent().parent().parent().siblings().children().children('.discount_type').val() == 'FLAT') {
                          $this.parent().parent().parent().siblings().children().children('.product_amount').val((((isNaN($this.parent().parent().parent().siblings().children().children('.unit_price').val()) ? 0 : $this.parent().parent().parent().siblings().children().children('.unit_price').val()) * ((isNaN($this.parent().parent().parent().siblings().children().children('.product_quantity').val()) ? 1 : $this.parent().parent().parent().siblings().children().children('.product_quantity').val()))) - (isNaN($this.parent().parent().parent().siblings().children().children('.product_discount').val()) ? 0 : $this.parent().parent().parent().siblings().children().children('.product_discount').val())));
                      } else {
                          $this.parent().parent().parent().siblings().children().children('.product_amount').val((((isNaN($this.parent().parent().parent().siblings().children().children('.unit_price').val()) ? 0 : $this.parent().parent().parent().siblings().children().children('.unit_price').val()) * ((isNaN($this.parent().parent().parent().siblings().children().children('.product_quantity').val()) ? 1 : $this.parent().parent().parent().siblings().children().children('.product_quantity').val())))));
                      }


                      subtotal();
                      total();
                      //   taxIncluded($(this).parent().parent().siblings().children().children('label').children('.product_tax_inc'));
                  }
              }
          });

          $("#add_new").click(function() {

              var count = $('.add-more').length;
              var dynacount = count + 1;
              $('#dynamic_field').append('<tr class=" add-more ' + count + '"><td class="text-center"><i class="fa fa-close removeind" aria-hidden="true" style="color: blue;"></i></td><td class="rendered"><div class=\"form-group field-product' + count + '\"><select class="product_details form-control" id=\"product' + count + '\" name="productdyn[' + dynacount + '][product]"><option value="">--Select--</option></select></div></td><td><div class=\"form-group field-includedescription' + count + '\"><input type="text" class="desc form-control" id=\"includedescription' + count + '\" name="productdyn[' + dynacount + '][desc]" ></div></td><td><div class=\"form-group field-includequantity' + count + '\"><input type="number" class="product_quantity form-control"  id=\"includequantity' + count + '\" name="productdyn[' + dynacount + '][quantity]" min=1 onkeypress="return (event.charCode == 8 || event.charCode == 0) ? null : event.charCode >= 48 && event.charCode <= 57"><div class="error-help">Quantity cant be negative or zero.</div></div></td><td><div class=\"form-group field-includeunits' + count + '\"><select  class="product_unit form-control" id=\"includeunits' + count + '\" name="productdyn[' + dynacount + '][units]"><option value="Nos">Nos</option><option value="Pcs">Pcs</option><option value="Pkt">Pkt</option></select></div></td><td><div class=\"form-group field-includeprice' + count + '\"><input type="number"  class="unit_price form-control" id=\"unitprice' + count + '\" name="productdyn[' + dynacount + '][unitprice]" min=0 step=.01 placeholder=0.00></div><div><input type="hidden" class="product_price form-control" id=\"includeprice' + count + '\" name="productdyn[' + dynacount + '][price]" readonly></div><div class="error-help">Enter valid price.</div><div class=\"form-group field-unitprice' + count + '\"></div></td><td><div class=\"form-group field-includediscount' + count + '\"><input type="number" class="product_discount form-control" id=\"includediscount' + count + '\" name="productdyn[' + dynacount + '][discount]" min=0 step=.01 placeholder=0.00 ></div><div class="error-help">Discount is not valid.</div>  </td><td><div class=\"form-group field-discounttype' + count + '\"><select class="form-control discount_type" id=\"discounttype' + count + '\" name="productdyn[' + dynacount + '][discounttype]"><option value>--Select--</option><option value="%">%</option><option value="FLAT">FLAT</option></select><div class="error-help">Discount Type cannot be blank.</div></div></td><td><div class=\"form-group field-includetax' + count + '\"><select class="product_tax form-control " id=\"includetax' + count + '\" name="productdyn[' + dynacount + '][tax]" ><option value=" ">--Select Tax--</option></select></div><div class="error-help">Enter Valid tax value.</div></td><td class="text-center"><div class=\"form-group field-tax_included' + count + '\"><input type="hidden"  value="0" name="productdyn[' + dynacount + '][tax_included]" checked><label><input type="checkbox" class="product_tax_inc" id=\"tax_included' + count + '\" value="1" name="productdyn[' + dynacount + '][tax_included]"></label></div></td><td><div class=\"form-group field-includeamount' + count + '\"><input type="text" class="product_amount form-control" id=\"includeamount' + count + '\" name="productdyn[' + dynacount + '][amount]" readonly></div><div class="error-help">Total amount cannot be negative.</div></td></tr>');
              var listItems = {};
              $('#includeunits' + count + '').select2();
              $('#discounttype' + count + '').select2();
              $('.product_details').select2({
                  ajax: {
                      url: '../leads-quotes/productdetails',
                      type: "get",
                      dataType: 'json',
                      delay: 250,
                      data: function(params) {
                          return {
                              searchTerm: params.term // search term
                          };
                      },
                      processResults: function(response) {
                          // console.log(response);
                          return {
                              results: $.map(response, function(i, item) {
                                  // console.log(i,item);
                                  return {
                                      text: i,
                                      slug: "",
                                      id: item
                                  }
                              })
                          };


                      },
                      cache: true
                  }
              });

              $('#includetax' + count + '').select2();
              $.get('../leads-quotes/finddetailsdropdown', function(data) {
                  $.each(JSON.parse(data), function(i, item) {
                      $('#includetax' + count + '').append($('<option value=\"' + i + '\">' + item + '</option>'));
                  });
              });


              $('.error-help').hide();
              $(document).on('click', ".removeind", function() {
                  $(this).parent().parent().remove();
                  var $this = $(this);
                  $this.parent().parent().siblings().children().children('.desc').val('');
                  $this.parent().parent().siblings().children().children('.product_price').val('');
                  $this.parent().parent().siblings().children().children('.unit_price').val('');
                  $this.parent().parent().siblings().children().children('.product_tax').val('');
                  $this.parent().parent().siblings().children().children('.product_unit').val('');
                  $this.parent().parent().siblings().children().children('.product_quantity').val('');
                  $this.parent().parent().siblings().children().children('.product_discount').val('');
                  $this.parent().parent().siblings().children().children('.discount_type').val('');
                  $this.parent().parent().siblings().children().children('.product_amount').val('');

                  subtotal();
                  total();
              });

          });

          function subtotal() {
            var subtotal= 0;
     var discount=0;
    //  $('.product_discount').each(function(){
        
    //  });

    $('.product_price').each(function(){
        var sub= parseFloat($(this).val());
        var qty=$(this).parent().parent().siblings().children().children('.product_quantity').val();
        if(isNaN(sub))
        sub =0;
        subtotal += parseFloat(sub);      
        var discounttype=$(this).parent().siblings().parent().siblings().children().children('.discount_type').val();
        var discountval=parseFloat($(this).parent().siblings().parent().siblings().children().children('.product_discount').val());
        
        if(isNaN(discountval))
        discountval=0;
        if(discountval){
        if(discounttype=='%'){
            discount+=parseFloat(parseFloat(sub)*(parseFloat(discountval)/100));
           var disc= parseFloat(parseFloat(sub)*(parseFloat(discountval)/100));
        }else{
            
            discount+=parseFloat(discountval);
            var disc= parseFloat(discountval);
        }
        }else{
            discount+=0;
            var disc=0;
        }
        $(this).parent().siblings().parent().siblings().children().children('.product_amount').val(sub- disc);
    });
    var finalval=parseFloat(parseFloat(subtotal)-parseFloat(discount));
    $('.subtotal').val(finalval);
    $('.subtotalamt').text(finalval.toFixed(2));
              $('.subtotalamt').text(((parseFloat(finalval)).toLocaleString('en-IN', {
                  minimumFractionDigits: 2,
                  maximumFractionDigits: 2,

              })));
          }
        //   var tax_details = $(this).parent().parent().parent().siblings().children().children('.product_tax').val();
        //   var tax = 0;
        //   tax = parseFloat(tax_details);
          
        function total()
    {
       
                var total= 0;
                var igst = 0;
                var sub_igst =0;
            
                var finalval = 0;
                $('.product_tax_inc').each(function()
                {   
                
                
                var tax_details = $(this).parent().parent().parent().siblings().children().children('.product_tax').val();
                // alert(tax_details);
                if (tax_details !== null && tax_details !== undefined && tax_details !== '') {
                        var tax =parseFloat(tax_details);
                       
                    if($(this).is(":checked"))
                    {  
                        
                    //   $this = $(this);
                                var product_quantity =$(this).parent().parent().parent().siblings().children().children('.product_quantity').val();
                                var dis_type= $(this).parent().parent().parent().siblings().children().children('.discount_type').val();
                                var baseAmount = parseFloat($(this).parent().parent().parent().siblings().children().children('.product_amount').val());
                                var hiddenAmt = parseFloat($(this).parent().parent().parent().siblings().children().children('.product_price').val());
                                
                                total =total +  baseAmount;
                                var taxAmount = parseFloat(baseAmount - (baseAmount / ((100 + tax)/100)));
                                var discounts=$(this).parent().parent().parent().siblings().children().children('.product_discount').val();
                            
                                var finalAmounts = baseAmount - taxAmount;
                            
                                if(dis_type=='%'){
                                    var total_price =parseFloat((finalAmounts/(100 - discounts)*100)/product_quantity);
                                }else{
                                    var total_price =parseFloat((hiddenAmt - taxAmount))/product_quantity;
                                }
                            // alert("swam");

                                
                                
                                $(this).parent().parent().parent().siblings().children().children('.unit_price').val(total_price.toFixed(2));
                                $(this).parent().parent().parent().siblings().children().children('.product_amount').val(finalAmounts.toFixed(2));
                
                                finalval+= finalAmounts;
                            //sub_igst =sub_igst + (   (  (((isNaN($this.parent().parent().parent().siblings().children().children('.unit_price').val())?0:$this.parent().parent().parent().siblings().children().children('.unit_price').val())*((isNaN($this.parent().parent().parent().siblings().children().children('.product_quantity').val())?1:$this.parent().parent().parent().siblings().children().children('.product_quantity').val())))-(   (  ((isNaN($this.parent().parent().parent().siblings().children().children('.unit_price').val())?0:$this.parent().parent().parent().siblings().children().children('.unit_price').val())*((isNaN($this.parent().parent().parent().siblings().children().children('.product_quantity').val())?1:$this.parent().parent().parent().siblings().children().children('.product_quantity').val()))) * (isNaN($this.parent().parent().parent().siblings().children().children('.product_discount').val())?0:$this.parent().parent().parent().siblings().children().children('.product_discount').val())  )/100   )) * (parseFloat(tax))  )/100   );
                            sub_igst = sub_igst + ((finalAmounts * parseFloat(tax)) / 100);
                    }else{
                        
                            
                                var dis_type= $(this).parent().parent().parent().siblings().children().children('.discount_type').val();
                                var baseAmount = parseFloat($(this).parent().parent().parent().siblings().children().children('.product_amount').val());
                                var qty =$(this).parent().parent().parent().siblings().children().children('.product_quantity').val(); 
                                var pricing = parseFloat($(this).parent().parent().parent().siblings().children().children('.product_price').val()/qty);
                                var taxAmount = parseFloat((baseAmount * tax) / 100);
                                var finalAmount =parseFloat(baseAmount + taxAmount);
                                $(this).parent().parent().parent().siblings().children().children('.product_amount').val(baseAmount.toFixed(2));
                                $(this).parent().parent().parent().siblings().children().children('.unit_price').val(pricing.toFixed(2));
                            total =total +  parseFloat(finalAmount);
                            sub_igst = sub_igst+  ((baseAmount * parseFloat(tax)) / 100); 
                        finalval+= baseAmount;
                            // alert(sub_igst);
                    } 
                }  
                    
                }); 
                if($('#round').is(":checked")){
                    $('#round').prop('checked',false)
                    $('#roundoffval').val('');
                }
                //alert(sub_igst);
            var final_amount = parseFloat(total);
            
            //    alert(final_amount);
                igst += parseFloat(sub_igst);
                $('.totaligst').text(igst.toFixed(2));
                $('.total_igst').val(igst); 
                $('.cgstvalue').text((igst/2).toFixed(2));
                $('.sgstvalue').text((igst/2).toFixed(2));
                $('.sgst').val(igst/2);
                $('.cgst').val(igst/2);
                $('.totalamount').val(final_amount);
                $('.totalamt').text(final_amount.toFixed(2));
                $('.totalamt').text((parseFloat(final_amount)).toLocaleString('en-IN', {
                  minimumFractionDigits: 2,
                  maximumFractionDigits: 2,

              }));
                $('.subtotal').val(finalval);
                $('.subtotalamt').text(finalval.toFixed(2));
                tcs();
    // roundoff();
  }
          $('.tcs_tax').change(function() {
              tcs();
          });
          $(document).on("change", ".unit_price", function() {
              tcs();
          })

          function tcs() {
              var t_amount = $('.totalamount').val();
              var tcs_amt = 0;
              var tcsamt;
              var totalamount = 0;
              $('.product_amount').each(function() {
                  totalamount += parseFloat($(this).val())
              })
              if ($('.tcs_tax').is(":checked")) {
                  var tcs_rate = <?= $tcs_rate ?>;
                  tcs_amt = parseFloat(parseFloat(tcs_rate) * parseFloat(totalamount) / 100);
                  var prev =parseFloat( $('.totalamount').val());
                  t_amount = parseFloat(prev)+ tcs_amt;
                  $('.totalamount').val(t_amount);
                  $('.totalamt').text((parseFloat(t_amount)).toLocaleString('en-IN', {
                      minimumFractionDigits: 2,
                      maximumFractionDigits: 2,

                  }));
              } else {
                  $('#saleorder-tcs_amount').val(0)
                  if (parseFloat($('#saleorder-tcs_amount').val()) > 0)
                      tcs_amt = parseFloat($('#saleorder-tcs_amount').val())
                  else
                      tcs_amt = 0;
                      var prev =parseFloat( $('.totalamount').val());
                        $('.totalamount').val(prev);
                        $('.totalamt').text(prev.toFixed(2));

                  $('.totalamt').text((parseFloat(prev)).toLocaleString('en-IN', {
                      minimumFractionDigits: 2,
                      maximumFractionDigits: 2,

                  }));
                  // $('.totalamt').text(totalamount.toFixed(2));
              }
              $('.tcsamt').text((tcs_amt).toFixed(2));
              $('.tcsamount').val((tcs_amt).toFixed(2));
              if ($('#round').is(":checked")) {
                  $('#round').prop('checked', false)
                  $('#roundoffval').val('');
              }

          }

          function tcschange() {
              var t_amount = $('.totalamount').val();
              var tcs_amt = parseFloat($('#saleorder-tcs_amount').val());
              var tcsamt;
              var totalamount = 0;
              $('.product_amount').each(function() {
                  totalamount += parseFloat($(this).val())
              })
              if ($('.tcs_tax').is(":checked")) {

                  // console.log(tcs_amt)
                  t_amount = parseFloat(totalamount) + tcs_amt;
                  $('.totalamount').val(t_amount);
                  $('.totalamt').text((parseFloat(t_amount)).toLocaleString('en-IN', {
                      minimumFractionDigits: 2,
                      maximumFractionDigits: 2,

                  }));
                  // $('.t_amount').text(t_amount.toFixed(2));
              } else {
                  $('#saleorder-tcs_amount').val(0)
                  if (parseFloat($('#saleorder-tcs_amount').val()) > 0)
                      tcs_amt = parseFloat($('#saleorder-tcs_amount').val())
                  else
                      tcs_amt = 0;

                  $('.totalamount').val(totalamount);
                  $('.totalamt').text((parseFloat(totalamount)).toLocaleString('en-IN', {
                      minimumFractionDigits: 2,
                      maximumFractionDigits: 2,

                  }));
                  // $('.totalamt').text(totalamount.toFixed(2));
              }
              $('.tcsamt').text((tcs_amt).toFixed(2));
              $('.tcsamount').val((tcs_amt).toFixed(2));

          }
          $('#round').change(function() {
              if ($(this).is(":checked")) {

                  var roundval = Math.round($('.totalamount').val()) - $('.totalamount').val();
                  $('.totalamt').text(Math.round(parseFloat($('.totalamount').val())).toLocaleString('en-IN', {
                      minimumFractionDigits: 2,
                      maximumFractionDigits: 2,

                  }));
                  // $('.totalamt').text(Math.round($('.totalamount').val()));
                  $('#roundoffval').val(roundval.toFixed(2)).trigger('change');
                  $('.totalamount').val(Math.round($('.totalamount').val()));
                  // $('#totalamount').val(Math.round($('#totalamount').val()));
              } else {
                  total();
                  $('#round').prop('checked', false)
                  $('#roundoffval').val('')
              }
          })
          if ($('#roundoffval').val() != '') {

              $('#round').prop('checked', true)
          }
          if ($('#round').is(":checked")) {
              var roundval = Math.round($('.totalamount').val()) - $('.totalamount').val();
              $('.totalamt').text(Math.round(parseFloat($('.totalamount').val())).toLocaleString('en-IN', {
                  minimumFractionDigits: 2,
                  maximumFractionDigits: 2,

              }));
              // else
              // {
              //     $('.totalamt').text(Math.round($('.totalamount').val()));
              // }

              // $('.totalamt').text(Math.round($('.totalamount').val()));
              $('#roundoffval').val(roundval.toFixed(2)).trigger('change');
              $('.totalamount').val(Math.round($('.totalamount').val()));
              // $('#totalamount').val(Math.round($('#totalamount').val()));
          }
          $('#saleorder-tcs_amount').change(function() {
              tcschange();
          })
          $('.line').hide();
          $('.advance').hide();
          $('#saleorder-advance_payment').change(function() {
              var value = $('input[name="SaleOrder[advance_payment]"]:checked').val();
              if (value == 'Advance payment for this Sales Order') {
                  $('.after_advance_line').show();
                  $('.after_advance_payment').show();
                  $('.line').show();
                  $('.advance').show();
              } else {
                  $('.after_advance_line').hide();
                  $('.after_advance_payment').hide();
                  $('.line').hide();
                  $('.advance').hide();
              }
          });
          $('.match').hide();
          $('.advance_matchreceipt').hide();
          $('#saleorder-advance_payment').change(function() {
              var value = $('input[name="SaleOrder[advance_payment]"]:checked').val();
              if (value == 'Matched Receipt') {
                  $('.after_matchreceipt').show();
                  $('.after_match').show();
                  $('.match').show();
                  $('.advance_matchreceipt').show();
              } else {
                  $('.after_matchreceipt').hide();
                  $('.after_match').hide();
                  $('.match').hide();
                  $('.advance_matchreceipt').hide();
              }
          });
          var isLoading = false;
          $('.attachments').click(function() {
              $("#dinamic").empty();
              isLoading = true;
              var id = $(this).attr('value');
              $.get('findattachments', {
                  id: id
              }, function(data) {
                  var data = $.parseJSON(data);
                  if (data.length == 0) {
                      $('#dinamic').append("<tr><td  value=''>No Attachments Found</td><tr>");
                  }
                  for (var i = 0; i < data.length; i++) {
                      $('#dinamic').append("<tr><td  value='" + data[i].id + "'>" + data[i].document_name + "  <i class='fa fa-times deleteattachment' style='color:#FF0000'  aria-hidden='true' data-dismiss='modal' value='" + data[i].id + "'></i></td><tr>");
                  }
                  $('.deleteattachment').click(function() {
                      var id = $(this).attr('value');
                      $.get('delattachment', {
                          id: id
                      }, function(data) {

                      })
                  })
                  isLoading = false;
              });
          });

          $("#saleorder-date").on("change", function() {
              var selected_date = $(this).val();
              var sel_date = new Date($(this).val());
              $.get('selectdate', {
                  selected_date: selected_date
              }, function(data) {
                  var d = new Date();
                  var output = d.getFullYear() + '-' + '03' + '-' + '31';

                  if (new Date(selected_date) <= new Date(output)) {
                      var dt = sel_date.getFullYear().toString().substr(-2);
                      var prv_dt = sel_date.getFullYear() - 1;
                      //var prefix_date = '/' + prv_dt + '-' + dt;
                      var prefix_date = '/' + (prv_dt.toString().substr(-2)) + '-' + dt;
                  } else {
                      var dt = sel_date.getFullYear();
                      var new_dt = (sel_date.getFullYear() + 1).toString().substr(-2);
                      //var prefix_date = '/' + dt + '-' + new_dt;
                      var prefix_date = '/' + dt.toString().substr(-2) + '-' + new_dt;
                  }


                  var data = $.parseJSON(data);
                  $('#saleorder-sale_order').val(data).trigger('change');
                  $('#saleorder-suffix').val(prefix_date).trigger('change');
                  $('#saleorder_label').empty();
                  $('#saleorder_label').append("Sales Order Last# " + (data - 1));

              })
          });

      });
  </script>
  <?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean())) ?>
